clc
clear all
close all

%% Note !!!!! After finishing post-processing using this script Save!!!
%% the workspace as 'Lin_Curvature_post_processed.mat'. It will be used
%% afterwards for the comparative study

%% Loading curvature data for the 20 examined current velocities
Lin_C1 = load('sima_elmcur_1.asc', '-ascii');
Lin_C2 = load('sima_elmcur_2.asc', '-ascii');
Lin_C3 = load('sima_elmcur_3.asc', '-ascii');
Lin_C4 = load('sima_elmcur_4.asc', '-ascii');
Lin_C5 = load('sima_elmcur_5.asc', '-ascii');
Lin_C6 = load('sima_elmcur_6.asc', '-ascii');
Lin_C7 = load('sima_elmcur_7.asc', '-ascii');
Lin_C8 = load('sima_elmcur_8.asc', '-ascii');
Lin_C9 = load('sima_elmcur_9.asc', '-ascii');
Lin_C10 = load('sima_elmcur_10.asc', '-ascii');
Lin_C11 = load('sima_elmcur_11.asc', '-ascii');
Lin_C12 = load('sima_elmcur_12.asc', '-ascii');
Lin_C13 = load('sima_elmcur_13.asc', '-ascii');
Lin_C14 = load('sima_elmcur_14.asc', '-ascii');
Lin_C15 = load('sima_elmcur_15.asc', '-ascii');
Lin_C16 = load('sima_elmcur_16.asc', '-ascii');
Lin_C17 = load('sima_elmcur_17.asc', '-ascii');
Lin_C18 = load('sima_elmcur_18.asc', '-ascii');
Lin_C19 = load('sima_elmcur_19.asc', '-ascii');
Lin_C20 = load('sima_elmcur_20.asc', '-ascii');
 
%% Load Static Configuration
Lin_Static_yz = load('Lin_Static_yz.asc', '-ascii'); 

%% Load Static Curvature
Lin_Static_cur = load('Lin_Static_cur.asc', '-ascii');

%% Removing transient
Lin_C1(1:23999,:)=[];
Lin_C2(1:23999,:)=[];
Lin_C3(1:23999,:)=[];
Lin_C4(1:23999,:)=[];
Lin_C5(1:23999,:)=[];
Lin_C6(1:23999,:)=[];
Lin_C7(1:23999,:)=[];
Lin_C8(1:23999,:)=[];
Lin_C9(1:23999,:)=[];
Lin_C10(1:23999,:)=[];
% Lin_C11(1:23999,:)=[];
Lin_C11(1:69999,:)=[];% a smaller timestep was used for this velocity
Lin_C12(1:23999,:)=[];
Lin_C13(1:23999,:)=[];
Lin_C14(1:23999,:)=[];
Lin_C15(1:23999,:)=[];
Lin_C16(1:23999,:)=[];
Lin_C17(1:23999,:)=[];
Lin_C18(1:23999,:)=[];
Lin_C19(1:23999,:)=[];
Lin_C20(1:23999,:)=[];

%%
%% Time series of Curvature about y axis
for n=1:(length(Lin_C1(1,:))-1)/4 
    counter=4*n-2;
Lin_Cur_y_1(:,n)=Lin_C1(:,counter);
Lin_Cur_y_2(:,n)=Lin_C2(:,counter);
Lin_Cur_y_3(:,n)=Lin_C3(:,counter);
Lin_Cur_y_4(:,n)=Lin_C4(:,counter);
Lin_Cur_y_5(:,n)=Lin_C5(:,counter);
Lin_Cur_y_6(:,n)=Lin_C6(:,counter);
Lin_Cur_y_7(:,n)=Lin_C7(:,counter);
Lin_Cur_y_8(:,n)=Lin_C8(:,counter);
Lin_Cur_y_9(:,n)=Lin_C9(:,counter);
Lin_Cur_y_10(:,n)=Lin_C10(:,counter);
Lin_Cur_y_11(:,n)=Lin_C11(:,counter);
Lin_Cur_y_12(:,n)=Lin_C12(:,counter);
Lin_Cur_y_13(:,n)=Lin_C13(:,counter);
Lin_Cur_y_14(:,n)=Lin_C14(:,counter);
Lin_Cur_y_15(:,n)=Lin_C15(:,counter);
Lin_Cur_y_16(:,n)=Lin_C16(:,counter);
Lin_Cur_y_17(:,n)=Lin_C17(:,counter);
Lin_Cur_y_18(:,n)=Lin_C18(:,counter);
Lin_Cur_y_19(:,n)=Lin_C19(:,counter);
Lin_Cur_y_20(:,n)=Lin_C20(:,counter);
end

Lin_Cur_y_1(:,n+1)=Lin_C1(:,end-2);
Lin_Cur_y_2(:,n+1)=Lin_C2(:,end-2);
Lin_Cur_y_3(:,n+1)=Lin_C3(:,end-2);
Lin_Cur_y_4(:,n+1)=Lin_C4(:,end-2);
Lin_Cur_y_5(:,n+1)=Lin_C5(:,end-2);
Lin_Cur_y_6(:,n+1)=Lin_C6(:,end-2);
Lin_Cur_y_7(:,n+1)=Lin_C7(:,end-2);
Lin_Cur_y_8(:,n+1)=Lin_C8(:,end-2);
Lin_Cur_y_9(:,n+1)=Lin_C9(:,end-2);
Lin_Cur_y_10(:,n+1)=Lin_C10(:,end-2);
Lin_Cur_y_11(:,n+1)=Lin_C11(:,end-2);
Lin_Cur_y_12(:,n+1)=Lin_C12(:,end-2);
Lin_Cur_y_13(:,n+1)=Lin_C13(:,end-2);
Lin_Cur_y_14(:,n+1)=Lin_C14(:,end-2);
Lin_Cur_y_15(:,n+1)=Lin_C15(:,end-2);
Lin_Cur_y_16(:,n+1)=Lin_C16(:,end-2);
Lin_Cur_y_17(:,n+1)=Lin_C17(:,end-2);
Lin_Cur_y_18(:,n+1)=Lin_C18(:,end-2);
Lin_Cur_y_19(:,n+1)=Lin_C19(:,end-2);
Lin_Cur_y_20(:,n+1)=Lin_C20(:,end-2);

%%
%% Time series of Curvature about z axis
for n=1:(length(Lin_C1(1,:))-1)/4 
    counter=4*n;
Lin_Cur_z_1(:,n)=Lin_C1(:,counter);
Lin_Cur_z_2(:,n)=Lin_C2(:,counter);
Lin_Cur_z_3(:,n)=Lin_C3(:,counter);
Lin_Cur_z_4(:,n)=Lin_C4(:,counter);
Lin_Cur_z_5(:,n)=Lin_C5(:,counter);
Lin_Cur_z_6(:,n)=Lin_C6(:,counter);
Lin_Cur_z_7(:,n)=Lin_C7(:,counter);
Lin_Cur_z_8(:,n)=Lin_C8(:,counter);
Lin_Cur_z_9(:,n)=Lin_C9(:,counter);
Lin_Cur_z_10(:,n)=Lin_C10(:,counter);
Lin_Cur_z_11(:,n)=Lin_C11(:,counter);
Lin_Cur_z_12(:,n)=Lin_C12(:,counter);
Lin_Cur_z_13(:,n)=Lin_C13(:,counter);
Lin_Cur_z_14(:,n)=Lin_C14(:,counter);
Lin_Cur_z_15(:,n)=Lin_C15(:,counter);
Lin_Cur_z_16(:,n)=Lin_C16(:,counter);
Lin_Cur_z_17(:,n)=Lin_C17(:,counter);
Lin_Cur_z_18(:,n)=Lin_C18(:,counter);
Lin_Cur_z_19(:,n)=Lin_C19(:,counter);
Lin_Cur_z_20(:,n)=Lin_C20(:,counter);

end

Lin_Cur_z_1(:,n+1)=Lin_C1(:,end);
Lin_Cur_z_2(:,n+1)=Lin_C2(:,end);
Lin_Cur_z_3(:,n+1)=Lin_C3(:,end);
Lin_Cur_z_4(:,n+1)=Lin_C4(:,end);
Lin_Cur_z_5(:,n+1)=Lin_C5(:,end);
Lin_Cur_z_6(:,n+1)=Lin_C6(:,end);
Lin_Cur_z_7(:,n+1)=Lin_C7(:,end);
Lin_Cur_z_8(:,n+1)=Lin_C8(:,end);
Lin_Cur_z_9(:,n+1)=Lin_C9(:,end);
Lin_Cur_z_10(:,n+1)=Lin_C10(:,end);
Lin_Cur_z_11(:,n+1)=Lin_C11(:,end);
Lin_Cur_z_12(:,n+1)=Lin_C12(:,end);
Lin_Cur_z_13(:,n+1)=Lin_C13(:,end);
Lin_Cur_z_14(:,n+1)=Lin_C14(:,end);
Lin_Cur_z_15(:,n+1)=Lin_C15(:,end);
Lin_Cur_z_16(:,n+1)=Lin_C16(:,end);
Lin_Cur_z_17(:,n+1)=Lin_C17(:,end);
Lin_Cur_z_18(:,n+1)=Lin_C18(:,end);
Lin_Cur_z_19(:,n+1)=Lin_C19(:,end);
Lin_Cur_z_20(:,n+1)=Lin_C20(:,end);

%%
%% General Input
D=0.702;                        % Hydrodynamic Diameter [m]
Ds=0.61;                        % Steel Pipe Diameter [m]
L=114;                          %Length [m]
nnod=length(Lin_Cur_y_1(1,:));  %Number of nodes
cord(1:61)=0:30/60:30;          %Length coordinates along the pipe
cord(61:81)=30:20.25/20:50.25;
cord(81:95)=50.25:13.5/14:63.75;
cord(95:115)=63.75:20.25/20:84;
cord(115:175)=84:30/60:114;
t11=Lin_C11(:,1)-Lin_C11(1,1);  %Time vector for the special case
ns11=length(t11);               %Number of data points for the special case
dt11=t11(2)-t11(1);             %Time step of sample for the special case
Fs11=1/dt11;                    %Sampling frequency for the special case

t=Lin_C1(:,1)-Lin_C1(1,1);      %Time vector
ns=length(t);                   %Number of data points
dt=t(2)-t(1);                   %Time step of sample
Fs=1/dt;                        %Sampling frequency
u_cur=0.5:0.1:2.4;              %Current velocities

%% Seafloor Configurations
Lin_Seafloor_disp = load('Lin_Seafloor_disp.asc', '-ascii');
Lin_Seafloor_z_initial=zeros(1,175);
Lin_Seafloor_x_initial=cord;
Lin_Seafloor_z_initial(1:61)=-399.8;
Lin_Seafloor_z_initial(62:114)=-401.0;
Lin_Seafloor_z_initial(115:175)=-399.8;
Lin_Seafloor_x_final=zeros(20,175);
Lin_Seafloor_z_final=zeros(20,175);
for n=1:20
    counter=2*n-1;
    Lin_Seafloor_x_final(n,:)=Lin_Seafloor_x_initial+Lin_Seafloor_disp(:,counter)';
end
for n=1:20
    counter=2*n;
    Lin_Seafloor_z_final(n,:)=Lin_Seafloor_z_initial-Lin_Seafloor_disp(:,counter)';
    Lin_Seafloor_z_final(n,61)=Lin_Static_yz(61,counter)';
end

%%
%% Remove Static Curvature about y axis
for n=1:(length(Lin_Cur_y_1(1,:)))
%     for n=1:nnod
        Lin_Cur_y_1(:,n)=Lin_Cur_y_1(:,n)-Lin_Static_cur(n,1);
        Lin_Cur_y_2(:,n)=Lin_Cur_y_2(:,n)-Lin_Static_cur(n,3);
        Lin_Cur_y_3(:,n)=Lin_Cur_y_3(:,n)-Lin_Static_cur(n,5);
        Lin_Cur_y_4(:,n)=Lin_Cur_y_4(:,n)-Lin_Static_cur(n,7);
        Lin_Cur_y_5(:,n)=Lin_Cur_y_5(:,n)-Lin_Static_cur(n,9);
        Lin_Cur_y_6(:,n)=Lin_Cur_y_6(:,n)-Lin_Static_cur(n,11);
        Lin_Cur_y_7(:,n)=Lin_Cur_y_7(:,n)-Lin_Static_cur(n,13);
        Lin_Cur_y_8(:,n)=Lin_Cur_y_8(:,n)-Lin_Static_cur(n,15);
        Lin_Cur_y_9(:,n)=Lin_Cur_y_9(:,n)-Lin_Static_cur(n,17);
        Lin_Cur_y_10(:,n)=Lin_Cur_y_10(:,n)-Lin_Static_cur(n,19);
        Lin_Cur_y_11(:,n)=Lin_Cur_y_11(:,n)-Lin_Static_cur(n,21);
        Lin_Cur_y_12(:,n)=Lin_Cur_y_12(:,n)-Lin_Static_cur(n,23);
        Lin_Cur_y_13(:,n)=Lin_Cur_y_13(:,n)-Lin_Static_cur(n,25);
        Lin_Cur_y_14(:,n)=Lin_Cur_y_14(:,n)-Lin_Static_cur(n,27);
        Lin_Cur_y_15(:,n)=Lin_Cur_y_15(:,n)-Lin_Static_cur(n,29);
        Lin_Cur_y_16(:,n)=Lin_Cur_y_16(:,n)-Lin_Static_cur(n,31);
        Lin_Cur_y_17(:,n)=Lin_Cur_y_17(:,n)-Lin_Static_cur(n,33);
        Lin_Cur_y_18(:,n)=Lin_Cur_y_18(:,n)-Lin_Static_cur(n,35);
        Lin_Cur_y_19(:,n)=Lin_Cur_y_19(:,n)-Lin_Static_cur(n,37);
        Lin_Cur_y_20(:,n)=Lin_Cur_y_20(:,n)-Lin_Static_cur(n,39);
end
    
  %%
%% Remove Static Curvature about z axis
for n=1:(length(Lin_Cur_z_1(1,:)))
%     for n=1:nnod
        Lin_Cur_z_1(:,n)=Lin_Cur_z_1(:,n)-Lin_Static_cur(n,2);
        Lin_Cur_z_2(:,n)=Lin_Cur_z_2(:,n)-Lin_Static_cur(n,4);
        Lin_Cur_z_3(:,n)=Lin_Cur_z_3(:,n)-Lin_Static_cur(n,6);
        Lin_Cur_z_4(:,n)=Lin_Cur_z_4(:,n)-Lin_Static_cur(n,8);
        Lin_Cur_z_5(:,n)=Lin_Cur_z_5(:,n)-Lin_Static_cur(n,10);
        Lin_Cur_z_6(:,n)=Lin_Cur_z_6(:,n)-Lin_Static_cur(n,12);
        Lin_Cur_z_7(:,n)=Lin_Cur_z_7(:,n)-Lin_Static_cur(n,14);
        Lin_Cur_z_8(:,n)=Lin_Cur_z_8(:,n)-Lin_Static_cur(n,16);
        Lin_Cur_z_9(:,n)=Lin_Cur_z_9(:,n)-Lin_Static_cur(n,18);
        Lin_Cur_z_10(:,n)=Lin_Cur_z_10(:,n)-Lin_Static_cur(n,20);
        Lin_Cur_z_11(:,n)=Lin_Cur_z_11(:,n)-Lin_Static_cur(n,22);
        Lin_Cur_z_12(:,n)=Lin_Cur_z_12(:,n)-Lin_Static_cur(n,24);
        Lin_Cur_z_13(:,n)=Lin_Cur_z_13(:,n)-Lin_Static_cur(n,26);
        Lin_Cur_z_14(:,n)=Lin_Cur_z_14(:,n)-Lin_Static_cur(n,28);
        Lin_Cur_z_15(:,n)=Lin_Cur_z_15(:,n)-Lin_Static_cur(n,30);
        Lin_Cur_z_16(:,n)=Lin_Cur_z_16(:,n)-Lin_Static_cur(n,32);
        Lin_Cur_z_17(:,n)=Lin_Cur_z_17(:,n)-Lin_Static_cur(n,34);
        Lin_Cur_z_18(:,n)=Lin_Cur_z_18(:,n)-Lin_Static_cur(n,36);
        Lin_Cur_z_19(:,n)=Lin_Cur_z_19(:,n)-Lin_Static_cur(n,38);
        Lin_Cur_z_20(:,n)=Lin_Cur_z_20(:,n)-Lin_Static_cur(n,40);
end
   
%%  Stress calculation
    E=2.07*10^11;
    Isyz=1.4*10^(-3);
    Isx=2*Isyz;
    Area=0.03185;
    %% Bending stress (MPa) cross-flow and in-line Based on Curvature
    %% Cross-flow
    Lin_SCur_y_1=E*Lin_Cur_y_1*Ds/2*1e-6; 
    Lin_SCur_y_2=E*Lin_Cur_y_2*Ds/2*1e-6;
    Lin_SCur_y_3=E*Lin_Cur_y_3*Ds/2*1e-6;
    Lin_SCur_y_4=E*Lin_Cur_y_4*Ds/2*1e-6;
    Lin_SCur_y_5=E*Lin_Cur_y_5*Ds/2*1e-6;
    Lin_SCur_y_6=E*Lin_Cur_y_6*Ds/2*1e-6;
    Lin_SCur_y_7=E*Lin_Cur_y_7*Ds/2*1e-6;
    Lin_SCur_y_8=E*Lin_Cur_y_8*Ds/2*1e-6;
    Lin_SCur_y_9=E*Lin_Cur_y_9*Ds/2*1e-6;
    Lin_SCur_y_10=E*Lin_Cur_y_10*Ds/2*1e-6;
    Lin_SCur_y_11=E*Lin_Cur_y_11*Ds/2*1e-6;
    Lin_SCur_y_12=E*Lin_Cur_y_12*Ds/2*1e-6;
    Lin_SCur_y_13=E*Lin_Cur_y_13*Ds/2*1e-6;
    Lin_SCur_y_14=E*Lin_Cur_y_14*Ds/2*1e-6;
    Lin_SCur_y_15=E*Lin_Cur_y_15*Ds/2*1e-6;
    Lin_SCur_y_16=E*Lin_Cur_y_16*Ds/2*1e-6;
    Lin_SCur_y_17=E*Lin_Cur_y_17*Ds/2*1e-6;
    Lin_SCur_y_18=E*Lin_Cur_y_18*Ds/2*1e-6;
    Lin_SCur_y_19=E*Lin_Cur_y_19*Ds/2*1e-6;
    Lin_SCur_y_20=E*Lin_Cur_y_20*Ds/2*1e-6;
    
    %% In-line 
    Lin_SCur_z_1=E*Lin_Cur_z_1*Ds/2*1e-6; 
    Lin_SCur_z_2=E*Lin_Cur_z_2*Ds/2*1e-6;
    Lin_SCur_z_3=E*Lin_Cur_z_3*Ds/2*1e-6;
    Lin_SCur_z_4=E*Lin_Cur_z_4*Ds/2*1e-6;
    Lin_SCur_z_5=E*Lin_Cur_z_5*Ds/2*1e-6;
    Lin_SCur_z_6=E*Lin_Cur_z_6*Ds/2*1e-6;
    Lin_SCur_z_7=E*Lin_Cur_z_7*Ds/2*1e-6;
    Lin_SCur_z_8=E*Lin_Cur_z_8*Ds/2*1e-6;
    Lin_SCur_z_9=E*Lin_Cur_z_9*Ds/2*1e-6;
    Lin_SCur_z_10=E*Lin_Cur_z_10*Ds/2*1e-6;
    Lin_SCur_z_11=E*Lin_Cur_z_11*Ds/2*1e-6;
    Lin_SCur_z_12=E*Lin_Cur_z_12*Ds/2*1e-6;
    Lin_SCur_z_13=E*Lin_Cur_z_13*Ds/2*1e-6;
    Lin_SCur_z_14=E*Lin_Cur_z_14*Ds/2*1e-6;
    Lin_SCur_z_15=E*Lin_Cur_z_15*Ds/2*1e-6;
    Lin_SCur_z_16=E*Lin_Cur_z_16*Ds/2*1e-6;
    Lin_SCur_z_17=E*Lin_Cur_z_17*Ds/2*1e-6;
    Lin_SCur_z_18=E*Lin_Cur_z_18*Ds/2*1e-6;
    Lin_SCur_z_19=E*Lin_Cur_z_19*Ds/2*1e-6;
    Lin_SCur_z_20=E*Lin_Cur_z_20*Ds/2*1e-6;
    
    %% Finding Maximum Stress
    %% Cross-flow
    Lin_SCur_y_max_1=max((Lin_SCur_y_1)); 
    Lin_SCur_y_max_2=max((Lin_SCur_y_2));
    Lin_SCur_y_max_3=max((Lin_SCur_y_3));
    Lin_SCur_y_max_4=max((Lin_SCur_y_4));
    Lin_SCur_y_max_5=max((Lin_SCur_y_5));
    Lin_SCur_y_max_6=max((Lin_SCur_y_6));
    Lin_SCur_y_max_7=max((Lin_SCur_y_7));
    Lin_SCur_y_max_8=max((Lin_SCur_y_8));
    Lin_SCur_y_max_9=max((Lin_SCur_y_9));
    Lin_SCur_y_max_10=max((Lin_SCur_y_10));
    Lin_SCur_y_max_11=max((Lin_SCur_y_11));
    Lin_SCur_y_max_12=max((Lin_SCur_y_12));
    Lin_SCur_y_max_13=max((Lin_SCur_y_13));
    Lin_SCur_y_max_14=max((Lin_SCur_y_14));
    Lin_SCur_y_max_15=max((Lin_SCur_y_15));
    Lin_SCur_y_max_16=max((Lin_SCur_y_16));
    Lin_SCur_y_max_17=max((Lin_SCur_y_17));
    Lin_SCur_y_max_18=max((Lin_SCur_y_18));
    Lin_SCur_y_max_19=max((Lin_SCur_y_19));
    Lin_SCur_y_max_20=max((Lin_SCur_y_20));
    
    %% In-line
    Lin_SCur_z_max_1=max((Lin_SCur_z_1)); 
    Lin_SCur_z_max_2=max((Lin_SCur_z_2));
    Lin_SCur_z_max_3=max((Lin_SCur_z_3));
    Lin_SCur_z_max_4=max((Lin_SCur_z_4));
    Lin_SCur_z_max_5=max((Lin_SCur_z_5));
    Lin_SCur_z_max_6=max((Lin_SCur_z_6));
    Lin_SCur_z_max_7=max((Lin_SCur_z_7));
    Lin_SCur_z_max_8=max((Lin_SCur_z_8));
    Lin_SCur_z_max_9=max((Lin_SCur_z_9));
    Lin_SCur_z_max_10=max((Lin_SCur_z_10));
    Lin_SCur_z_max_11=max((Lin_SCur_z_11));
    Lin_SCur_z_max_12=max((Lin_SCur_z_12));
    Lin_SCur_z_max_13=max((Lin_SCur_z_13));
    Lin_SCur_z_max_14=max((Lin_SCur_z_14));
    Lin_SCur_z_max_15=max((Lin_SCur_z_15));
    Lin_SCur_z_max_16=max((Lin_SCur_z_16));
    Lin_SCur_z_max_17=max((Lin_SCur_z_17));
    Lin_SCur_z_max_18=max((Lin_SCur_z_18));
    Lin_SCur_z_max_19=max((Lin_SCur_z_19));
    Lin_SCur_z_max_20=max((Lin_SCur_z_20));
    
    %% Finding Minimum Stress
    %% Cross-flow
    Lin_SCur_y_min_1=min((Lin_SCur_y_1)); 
    Lin_SCur_y_min_2=min((Lin_SCur_y_2));
    Lin_SCur_y_min_3=min((Lin_SCur_y_3));
    Lin_SCur_y_min_4=min((Lin_SCur_y_4));
    Lin_SCur_y_min_5=min((Lin_SCur_y_5));
    Lin_SCur_y_min_6=min((Lin_SCur_y_6));
    Lin_SCur_y_min_7=min((Lin_SCur_y_7));
    Lin_SCur_y_min_8=min((Lin_SCur_y_8));
    Lin_SCur_y_min_9=min((Lin_SCur_y_9));
    Lin_SCur_y_min_10=min((Lin_SCur_y_10));
    Lin_SCur_y_min_11=min((Lin_SCur_y_11));
    Lin_SCur_y_min_12=min((Lin_SCur_y_12));
    Lin_SCur_y_min_13=min((Lin_SCur_y_13));
    Lin_SCur_y_min_14=min((Lin_SCur_y_14));
    Lin_SCur_y_min_15=min((Lin_SCur_y_15));
    Lin_SCur_y_min_16=min((Lin_SCur_y_16));
    Lin_SCur_y_min_17=min((Lin_SCur_y_17));
    Lin_SCur_y_min_18=min((Lin_SCur_y_18));
    Lin_SCur_y_min_19=min((Lin_SCur_y_19));
    Lin_SCur_y_min_20=min((Lin_SCur_y_20));

    %% In-line
    Lin_SCur_z_min_1=min((Lin_SCur_z_1)); 
    Lin_SCur_z_min_2=min((Lin_SCur_z_2));
    Lin_SCur_z_min_3=min((Lin_SCur_z_3));
    Lin_SCur_z_min_4=min((Lin_SCur_z_4));
    Lin_SCur_z_min_5=min((Lin_SCur_z_5));
    Lin_SCur_z_min_6=min((Lin_SCur_z_6));
    Lin_SCur_z_min_7=min((Lin_SCur_z_7));
    Lin_SCur_z_min_8=min((Lin_SCur_z_8));
    Lin_SCur_z_min_9=min((Lin_SCur_z_9));
    Lin_SCur_z_min_10=min((Lin_SCur_z_10));
    Lin_SCur_z_min_11=min((Lin_SCur_z_11));
    Lin_SCur_z_min_12=min((Lin_SCur_z_12));
    Lin_SCur_z_min_13=min((Lin_SCur_z_13));
    Lin_SCur_z_min_14=min((Lin_SCur_z_14));
    Lin_SCur_z_min_15=min((Lin_SCur_z_15));
    Lin_SCur_z_min_16=min((Lin_SCur_z_16));
    Lin_SCur_z_min_17=min((Lin_SCur_z_17));
    Lin_SCur_z_min_18=min((Lin_SCur_z_18));
    Lin_SCur_z_min_19=min((Lin_SCur_z_19));
    Lin_SCur_z_min_20=min((Lin_SCur_z_20));
    
    %% Finding Mean Stress
    %% Cross-flow
    Lin_SCur_y_mean_1=mean((Lin_SCur_y_1)); 
    Lin_SCur_y_mean_2=mean((Lin_SCur_y_2));
    Lin_SCur_y_mean_3=mean((Lin_SCur_y_3));
    Lin_SCur_y_mean_4=mean((Lin_SCur_y_4));
    Lin_SCur_y_mean_5=mean((Lin_SCur_y_5));
    Lin_SCur_y_mean_6=mean((Lin_SCur_y_6));
    Lin_SCur_y_mean_7=mean((Lin_SCur_y_7));
    Lin_SCur_y_mean_8=mean((Lin_SCur_y_8));
    Lin_SCur_y_mean_9=mean((Lin_SCur_y_9));
    Lin_SCur_y_mean_10=mean((Lin_SCur_y_10));
    Lin_SCur_y_mean_11=mean((Lin_SCur_y_11));
    Lin_SCur_y_mean_12=mean((Lin_SCur_y_12));
    Lin_SCur_y_mean_13=mean((Lin_SCur_y_13));
    Lin_SCur_y_mean_14=mean((Lin_SCur_y_14));
    Lin_SCur_y_mean_15=mean((Lin_SCur_y_15));
    Lin_SCur_y_mean_16=mean((Lin_SCur_y_16));
    Lin_SCur_y_mean_17=mean((Lin_SCur_y_17));
    Lin_SCur_y_mean_18=mean((Lin_SCur_y_18));
    Lin_SCur_y_mean_19=mean((Lin_SCur_y_19));
    Lin_SCur_y_mean_20=mean((Lin_SCur_y_20));

    %% In-line
    Lin_SCur_z_mean_1=mean((Lin_SCur_z_1)); 
    Lin_SCur_z_mean_2=mean((Lin_SCur_z_2));
    Lin_SCur_z_mean_3=mean((Lin_SCur_z_3));
    Lin_SCur_z_mean_4=mean((Lin_SCur_z_4));
    Lin_SCur_z_mean_5=mean((Lin_SCur_z_5));
    Lin_SCur_z_mean_6=mean((Lin_SCur_z_6));
    Lin_SCur_z_mean_7=mean((Lin_SCur_z_7));
    Lin_SCur_z_mean_8=mean((Lin_SCur_z_8));
    Lin_SCur_z_mean_9=mean((Lin_SCur_z_9));
    Lin_SCur_z_mean_10=mean((Lin_SCur_z_10));
    Lin_SCur_z_mean_11=mean((Lin_SCur_z_11));
    Lin_SCur_z_mean_12=mean((Lin_SCur_z_12));
    Lin_SCur_z_mean_13=mean((Lin_SCur_z_13));
    Lin_SCur_z_mean_14=mean((Lin_SCur_z_14));
    Lin_SCur_z_mean_15=mean((Lin_SCur_z_15));
    Lin_SCur_z_mean_16=mean((Lin_SCur_z_16));
    Lin_SCur_z_mean_17=mean((Lin_SCur_z_17));
    Lin_SCur_z_mean_18=mean((Lin_SCur_z_18));
    Lin_SCur_z_mean_19=mean((Lin_SCur_z_19));
    Lin_SCur_z_mean_20=mean((Lin_SCur_z_20));
    
    %%  Fatigue calculation
    % SN curve parameters
    m0=3;
    K0=10^(-11.63);
    % Rain-flow counting
 
    for i=1:length(Lin_SCur_y_1(1,:))
        %Find turning points in stress time series
        Lin_TP_SCur_y_1=dat2tp(Lin_SCur_y_1(:,i)); 
        Lin_TP_SCur_y_2=dat2tp(Lin_SCur_y_2(:,i));
        Lin_TP_SCur_y_3=dat2tp(Lin_SCur_y_3(:,i));
        Lin_TP_SCur_y_4=dat2tp(Lin_SCur_y_4(:,i));
        Lin_TP_SCur_y_5=dat2tp(Lin_SCur_y_5(:,i));
        Lin_TP_SCur_y_6=dat2tp(Lin_SCur_y_6(:,i));
        Lin_TP_SCur_y_7=dat2tp(Lin_SCur_y_7(:,i));
        Lin_TP_SCur_y_8=dat2tp(Lin_SCur_y_8(:,i));
        Lin_TP_SCur_y_9=dat2tp(Lin_SCur_y_9(:,i));
        Lin_TP_SCur_y_10=dat2tp(Lin_SCur_y_10(:,i));
        Lin_TP_SCur_y_11=dat2tp(Lin_SCur_y_11(:,i));
        Lin_TP_SCur_y_12=dat2tp(Lin_SCur_y_12(:,i));
        Lin_TP_SCur_y_13=dat2tp(Lin_SCur_y_13(:,i));
        Lin_TP_SCur_y_14=dat2tp(Lin_SCur_y_14(:,i));
        Lin_TP_SCur_y_15=dat2tp(Lin_SCur_y_15(:,i));
        Lin_TP_SCur_y_16=dat2tp(Lin_SCur_y_16(:,i));
        Lin_TP_SCur_y_17=dat2tp(Lin_SCur_y_17(:,i));
        Lin_TP_SCur_y_18=dat2tp(Lin_SCur_y_18(:,i));
        Lin_TP_SCur_y_19=dat2tp(Lin_SCur_y_19(:,i));
        Lin_TP_SCur_y_20=dat2tp(Lin_SCur_y_20(:,i));
       
        
        Lin_TP_SCur_z_1=dat2tp(Lin_SCur_z_1(:,i)); 
        Lin_TP_SCur_z_2=dat2tp(Lin_SCur_z_2(:,i));
        Lin_TP_SCur_z_3=dat2tp(Lin_SCur_z_3(:,i));
        Lin_TP_SCur_z_4=dat2tp(Lin_SCur_z_4(:,i));
        Lin_TP_SCur_z_5=dat2tp(Lin_SCur_z_5(:,i));
        Lin_TP_SCur_z_6=dat2tp(Lin_SCur_z_6(:,i));
        Lin_TP_SCur_z_7=dat2tp(Lin_SCur_z_7(:,i));
        Lin_TP_SCur_z_8=dat2tp(Lin_SCur_z_8(:,i));
        Lin_TP_SCur_z_9=dat2tp(Lin_SCur_z_9(:,i));
        Lin_TP_SCur_z_10=dat2tp(Lin_SCur_z_10(:,i));
        Lin_TP_SCur_z_11=dat2tp(Lin_SCur_z_11(:,i));
        Lin_TP_SCur_z_12=dat2tp(Lin_SCur_z_12(:,i));
        Lin_TP_SCur_z_13=dat2tp(Lin_SCur_z_13(:,i));
        Lin_TP_SCur_z_14=dat2tp(Lin_SCur_z_14(:,i));
        Lin_TP_SCur_z_15=dat2tp(Lin_SCur_z_15(:,i));
        Lin_TP_SCur_z_16=dat2tp(Lin_SCur_z_16(:,i));
        Lin_TP_SCur_z_17=dat2tp(Lin_SCur_z_17(:,i));
        Lin_TP_SCur_z_18=dat2tp(Lin_SCur_z_18(:,i));
        Lin_TP_SCur_z_19=dat2tp(Lin_SCur_z_19(:,i));
        Lin_TP_SCur_z_20=dat2tp(Lin_SCur_z_20(:,i));

        
        %Find rainflow stress cycles
        [Lin_RFC_SCur_y_1] = tp2rfc(Lin_TP_SCur_y_1);
        [Lin_RFC_SCur_y_2] = tp2rfc(Lin_TP_SCur_y_2);
        [Lin_RFC_SCur_y_3] = tp2rfc(Lin_TP_SCur_y_3);
        [Lin_RFC_SCur_y_4] = tp2rfc(Lin_TP_SCur_y_4);
        [Lin_RFC_SCur_y_5] = tp2rfc(Lin_TP_SCur_y_5);
        [Lin_RFC_SCur_y_6] = tp2rfc(Lin_TP_SCur_y_6);
        [Lin_RFC_SCur_y_7] = tp2rfc(Lin_TP_SCur_y_7);
        [Lin_RFC_SCur_y_8] = tp2rfc(Lin_TP_SCur_y_8);
        [Lin_RFC_SCur_y_9] = tp2rfc(Lin_TP_SCur_y_9);
        [Lin_RFC_SCur_y_10] = tp2rfc(Lin_TP_SCur_y_10);
        [Lin_RFC_SCur_y_11] = tp2rfc(Lin_TP_SCur_y_11);
        [Lin_RFC_SCur_y_12] = tp2rfc(Lin_TP_SCur_y_12);
        [Lin_RFC_SCur_y_13] = tp2rfc(Lin_TP_SCur_y_13);
        [Lin_RFC_SCur_y_14] = tp2rfc(Lin_TP_SCur_y_14);
        [Lin_RFC_SCur_y_15] = tp2rfc(Lin_TP_SCur_y_15);
        [Lin_RFC_SCur_y_16] = tp2rfc(Lin_TP_SCur_y_16);
        [Lin_RFC_SCur_y_17] = tp2rfc(Lin_TP_SCur_y_17);
        [Lin_RFC_SCur_y_18] = tp2rfc(Lin_TP_SCur_y_18);
        [Lin_RFC_SCur_y_19] = tp2rfc(Lin_TP_SCur_y_19);
        [Lin_RFC_SCur_y_20] = tp2rfc(Lin_TP_SCur_y_20);

        
        [Lin_RFC_SCur_z_1] = tp2rfc(Lin_TP_SCur_z_1);
        [Lin_RFC_SCur_z_2] = tp2rfc(Lin_TP_SCur_z_2);
        [Lin_RFC_SCur_z_3] = tp2rfc(Lin_TP_SCur_z_3);
        [Lin_RFC_SCur_z_4] = tp2rfc(Lin_TP_SCur_z_4);
        [Lin_RFC_SCur_z_5] = tp2rfc(Lin_TP_SCur_z_5);
        [Lin_RFC_SCur_z_6] = tp2rfc(Lin_TP_SCur_z_6);
        [Lin_RFC_SCur_z_7] = tp2rfc(Lin_TP_SCur_z_7);
        [Lin_RFC_SCur_z_8] = tp2rfc(Lin_TP_SCur_z_8);
        [Lin_RFC_SCur_z_9] = tp2rfc(Lin_TP_SCur_z_9);
        [Lin_RFC_SCur_z_10] = tp2rfc(Lin_TP_SCur_z_10);
        [Lin_RFC_SCur_z_11] = tp2rfc(Lin_TP_SCur_z_11);
        [Lin_RFC_SCur_z_12] = tp2rfc(Lin_TP_SCur_z_12);
        [Lin_RFC_SCur_z_13] = tp2rfc(Lin_TP_SCur_z_13);
        [Lin_RFC_SCur_z_14] = tp2rfc(Lin_TP_SCur_z_14);
        [Lin_RFC_SCur_z_15] = tp2rfc(Lin_TP_SCur_z_15);
        [Lin_RFC_SCur_z_16] = tp2rfc(Lin_TP_SCur_z_16);
        [Lin_RFC_SCur_z_17] = tp2rfc(Lin_TP_SCur_z_17);
        [Lin_RFC_SCur_z_18] = tp2rfc(Lin_TP_SCur_z_18);
        [Lin_RFC_SCur_z_19] = tp2rfc(Lin_TP_SCur_z_19);
        [Lin_RFC_SCur_z_20] = tp2rfc(Lin_TP_SCur_z_20);

        
        % One-year fatigue damage
        Lin_D_SCur_y_1(i) = cc2dam(Lin_RFC_SCur_y_1,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_2(i) = cc2dam(Lin_RFC_SCur_y_2,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_3(i) = cc2dam(Lin_RFC_SCur_y_3,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_4(i) = cc2dam(Lin_RFC_SCur_y_4,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_5(i) = cc2dam(Lin_RFC_SCur_y_5,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_6(i) = cc2dam(Lin_RFC_SCur_y_6,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_7(i) = cc2dam(Lin_RFC_SCur_y_7,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_8(i) = cc2dam(Lin_RFC_SCur_y_8,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_9(i) = cc2dam(Lin_RFC_SCur_y_9,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_10(i) = cc2dam(Lin_RFC_SCur_y_10,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_11(i) = cc2dam(Lin_RFC_SCur_y_11,m0,K0)*2^m0/(ns11*dt11)*3600*24*365;
        Lin_D_SCur_y_12(i) = cc2dam(Lin_RFC_SCur_y_12,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_13(i) = cc2dam(Lin_RFC_SCur_y_13,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_14(i) = cc2dam(Lin_RFC_SCur_y_14,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_15(i) = cc2dam(Lin_RFC_SCur_y_15,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_16(i) = cc2dam(Lin_RFC_SCur_y_16,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_17(i) = cc2dam(Lin_RFC_SCur_y_17,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_18(i) = cc2dam(Lin_RFC_SCur_y_18,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_19(i) = cc2dam(Lin_RFC_SCur_y_19,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_y_20(i) = cc2dam(Lin_RFC_SCur_y_20,m0,K0)*2^m0/(ns*dt)*3600*24*365;

        
        Lin_D_SCur_z_1(i) = cc2dam(Lin_RFC_SCur_z_1,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_2(i) = cc2dam(Lin_RFC_SCur_z_2,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_3(i) = cc2dam(Lin_RFC_SCur_z_3,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_4(i) = cc2dam(Lin_RFC_SCur_z_4,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_5(i) = cc2dam(Lin_RFC_SCur_z_5,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_6(i) = cc2dam(Lin_RFC_SCur_z_6,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_7(i) = cc2dam(Lin_RFC_SCur_z_7,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_8(i) = cc2dam(Lin_RFC_SCur_z_8,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_9(i) = cc2dam(Lin_RFC_SCur_z_9,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_10(i) = cc2dam(Lin_RFC_SCur_z_10,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_11(i) = cc2dam(Lin_RFC_SCur_z_11,m0,K0)*2^m0/(ns11*dt11)*3600*24*365;
        Lin_D_SCur_z_12(i) = cc2dam(Lin_RFC_SCur_z_12,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_13(i) = cc2dam(Lin_RFC_SCur_z_13,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_14(i) = cc2dam(Lin_RFC_SCur_z_14,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_15(i) = cc2dam(Lin_RFC_SCur_z_15,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_16(i) = cc2dam(Lin_RFC_SCur_z_16,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_17(i) = cc2dam(Lin_RFC_SCur_z_17,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_18(i) = cc2dam(Lin_RFC_SCur_z_18,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_19(i) = cc2dam(Lin_RFC_SCur_z_19,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_z_20(i) = cc2dam(Lin_RFC_SCur_z_20,m0,K0)*2^m0/(ns*dt)*3600*24*365;

 
    end
    
    %% 8 points around the circumference
    
    for theta=0:pi/4:7*pi/4
    Lin_SCur_1=(E*Lin_Cur_y_1*Ds/2*sin(theta)+E*Lin_Cur_z_1*Ds/2*cos(theta))*1e-6; 
    Lin_SCur_2=(E*Lin_Cur_y_2*Ds/2*sin(theta)+E*Lin_Cur_z_2*Ds/2*cos(theta))*1e-6;
    Lin_SCur_3=(E*Lin_Cur_y_3*Ds/2*sin(theta)+E*Lin_Cur_z_3*Ds/2*cos(theta))*1e-6;
    Lin_SCur_4=(E*Lin_Cur_y_4*Ds/2*sin(theta)+E*Lin_Cur_z_4*Ds/2*cos(theta))*1e-6;
    Lin_SCur_5=(E*Lin_Cur_y_5*Ds/2*sin(theta)+E*Lin_Cur_z_5*Ds/2*cos(theta))*1e-6;
    Lin_SCur_6=(E*Lin_Cur_y_6*Ds/2*sin(theta)+E*Lin_Cur_z_6*Ds/2*cos(theta))*1e-6;
    Lin_SCur_7=(E*Lin_Cur_y_7*Ds/2*sin(theta)+E*Lin_Cur_z_7*Ds/2*cos(theta))*1e-6;
    Lin_SCur_8=(E*Lin_Cur_y_8*Ds/2*sin(theta)+E*Lin_Cur_z_8*Ds/2*cos(theta))*1e-6;
    Lin_SCur_9=(E*Lin_Cur_y_9*Ds/2*sin(theta)+E*Lin_Cur_z_9*Ds/2*cos(theta))*1e-6;
    Lin_SCur_10=(E*Lin_Cur_y_10*Ds/2*sin(theta)+E*Lin_Cur_z_10*Ds/2*cos(theta))*1e-6;
    Lin_SCur_11=(E*Lin_Cur_y_11*Ds/2*sin(theta)+E*Lin_Cur_z_11*Ds/2*cos(theta))*1e-6;
    Lin_SCur_12=(E*Lin_Cur_y_12*Ds/2*sin(theta)+E*Lin_Cur_z_12*Ds/2*cos(theta))*1e-6;
    Lin_SCur_13=(E*Lin_Cur_y_13*Ds/2*sin(theta)+E*Lin_Cur_z_13*Ds/2*cos(theta))*1e-6;
    Lin_SCur_14=(E*Lin_Cur_y_14*Ds/2*sin(theta)+E*Lin_Cur_z_14*Ds/2*cos(theta))*1e-6;
    Lin_SCur_15=(E*Lin_Cur_y_15*Ds/2*sin(theta)+E*Lin_Cur_z_15*Ds/2*cos(theta))*1e-6;
    Lin_SCur_16=(E*Lin_Cur_y_16*Ds/2*sin(theta)+E*Lin_Cur_z_16*Ds/2*cos(theta))*1e-6;
    Lin_SCur_17=(E*Lin_Cur_y_17*Ds/2*sin(theta)+E*Lin_Cur_z_17*Ds/2*cos(theta))*1e-6;
    Lin_SCur_18=(E*Lin_Cur_y_18*Ds/2*sin(theta)+E*Lin_Cur_z_18*Ds/2*cos(theta))*1e-6;
    Lin_SCur_19=(E*Lin_Cur_y_19*Ds/2*sin(theta)+E*Lin_Cur_z_19*Ds/2*cos(theta))*1e-6;
    Lin_SCur_20=(E*Lin_Cur_y_20*Ds/2*sin(theta)+E*Lin_Cur_z_20*Ds/2*cos(theta))*1e-6;

    
    for i=1:length(Lin_SCur_y_1(1,:))
        %Find turning points in stress time series
        Lin_TP_SCur_1=dat2tp(Lin_SCur_1(:,i)); 
        Lin_TP_SCur_2=dat2tp(Lin_SCur_2(:,i));
        Lin_TP_SCur_3=dat2tp(Lin_SCur_3(:,i));
        Lin_TP_SCur_4=dat2tp(Lin_SCur_4(:,i));
        Lin_TP_SCur_5=dat2tp(Lin_SCur_5(:,i));
        Lin_TP_SCur_6=dat2tp(Lin_SCur_6(:,i));
        Lin_TP_SCur_7=dat2tp(Lin_SCur_7(:,i));
        Lin_TP_SCur_8=dat2tp(Lin_SCur_8(:,i));
        Lin_TP_SCur_9=dat2tp(Lin_SCur_9(:,i));
        Lin_TP_SCur_10=dat2tp(Lin_SCur_10(:,i));
        Lin_TP_SCur_11=dat2tp(Lin_SCur_11(:,i));
        Lin_TP_SCur_12=dat2tp(Lin_SCur_12(:,i));
        Lin_TP_SCur_13=dat2tp(Lin_SCur_13(:,i));
        Lin_TP_SCur_14=dat2tp(Lin_SCur_14(:,i));
        Lin_TP_SCur_15=dat2tp(Lin_SCur_15(:,i));
        Lin_TP_SCur_16=dat2tp(Lin_SCur_16(:,i));
        Lin_TP_SCur_17=dat2tp(Lin_SCur_17(:,i));
        Lin_TP_SCur_18=dat2tp(Lin_SCur_18(:,i));
        Lin_TP_SCur_19=dat2tp(Lin_SCur_19(:,i));
        Lin_TP_SCur_20=dat2tp(Lin_SCur_20(:,i));

        
        %Find rainflow stress cycles
        [Lin_RFC_SCur_1] = tp2rfc(Lin_TP_SCur_1);
        [Lin_RFC_SCur_2] = tp2rfc(Lin_TP_SCur_2);
        [Lin_RFC_SCur_3] = tp2rfc(Lin_TP_SCur_3);
        [Lin_RFC_SCur_4] = tp2rfc(Lin_TP_SCur_4);
        [Lin_RFC_SCur_5] = tp2rfc(Lin_TP_SCur_5);
        [Lin_RFC_SCur_6] = tp2rfc(Lin_TP_SCur_6);
        [Lin_RFC_SCur_7] = tp2rfc(Lin_TP_SCur_7);
        [Lin_RFC_SCur_8] = tp2rfc(Lin_TP_SCur_8);
        [Lin_RFC_SCur_9] = tp2rfc(Lin_TP_SCur_9);
        [Lin_RFC_SCur_10] = tp2rfc(Lin_TP_SCur_10);
        [Lin_RFC_SCur_11] = tp2rfc(Lin_TP_SCur_11);
        [Lin_RFC_SCur_12] = tp2rfc(Lin_TP_SCur_12);
        [Lin_RFC_SCur_13] = tp2rfc(Lin_TP_SCur_13);
        [Lin_RFC_SCur_14] = tp2rfc(Lin_TP_SCur_14);
        [Lin_RFC_SCur_15] = tp2rfc(Lin_TP_SCur_15);
        [Lin_RFC_SCur_16] = tp2rfc(Lin_TP_SCur_16);
        [Lin_RFC_SCur_17] = tp2rfc(Lin_TP_SCur_17);
        [Lin_RFC_SCur_18] = tp2rfc(Lin_TP_SCur_18);
        [Lin_RFC_SCur_19] = tp2rfc(Lin_TP_SCur_19);
        [Lin_RFC_SCur_20] = tp2rfc(Lin_TP_SCur_20);

        
        % One-year fatigue damage
        Lin_D_SCur_1(theta,i) = cc2dam(Lin_RFC_SCur_1,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_2(theta,i) = cc2dam(Lin_RFC_SCur_2,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_3(theta,i) = cc2dam(Lin_RFC_SCur_3,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_4(theta,i) = cc2dam(Lin_RFC_SCur_4,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_5(theta,i) = cc2dam(Lin_RFC_SCur_5,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_6(theta,i) = cc2dam(Lin_RFC_SCur_6,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_7(theta,i) = cc2dam(Lin_RFC_SCur_7,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_8(theta,i) = cc2dam(Lin_RFC_SCur_8,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_9(theta,i) = cc2dam(Lin_RFC_SCur_9,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_10(theta,i) = cc2dam(Lin_RFC_SCur_10,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_11(theta,i) = cc2dam(Lin_RFC_SCur_11,m0,K0)*2^m0/(ns11*dt11)*3600*24*365;
        Lin_D_SCur_12(theta,i) = cc2dam(Lin_RFC_SCur_12,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_13(theta,i) = cc2dam(Lin_RFC_SCur_13,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_14(theta,i) = cc2dam(Lin_RFC_SCur_14,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_15(theta,i) = cc2dam(Lin_RFC_SCur_15,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_16(theta,i) = cc2dam(Lin_RFC_SCur_16,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_17(theta,i) = cc2dam(Lin_RFC_SCur_17,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_18(theta,i) = cc2dam(Lin_RFC_SCur_18,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_19(theta,i) = cc2dam(Lin_RFC_SCur_19,m0,K0)*2^m0/(ns*dt)*3600*24*365;
        Lin_D_SCur_20(theta,i) = cc2dam(Lin_RFC_SCur_20,m0,K0)*2^m0/(ns*dt)*3600*24*365;

        
    end
    end 
 
%% Plots

%% Maximum Bending stress about y-axis (CF) along the pipeline

figure
hold on
plot(cord,Lin_SCur_y_max_1)
plot(cord,Lin_SCur_y_max_2)
plot(cord,Lin_SCur_y_max_3)
plot(cord,Lin_SCur_y_max_4)
plot(cord,Lin_SCur_y_max_5)
plot(cord,Lin_SCur_y_max_6)
plot(cord,Lin_SCur_y_max_7)
plot(cord,Lin_SCur_y_max_8)
plot(cord,Lin_SCur_y_max_9)
plot(cord,Lin_SCur_y_max_10)
plot(cord,Lin_SCur_y_max_11)
plot(cord,Lin_SCur_y_max_12)
plot(cord,Lin_SCur_y_max_13)
plot(cord,Lin_SCur_y_max_14)
plot(cord,Lin_SCur_y_max_15)
plot(cord,Lin_SCur_y_max_16)
plot(cord,Lin_SCur_y_max_17)
plot(cord,Lin_SCur_y_max_18)
plot(cord,Lin_SCur_y_max_19)
plot(cord,Lin_SCur_y_max_20)

hold off
title('Maximum CF Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)

%% Minimum Bending stress about y-axis (CF) along the pipeline

figure
hold on
plot(cord,Lin_SCur_y_min_1)
plot(cord,Lin_SCur_y_min_2)
plot(cord,Lin_SCur_y_min_3)
plot(cord,Lin_SCur_y_min_4)
plot(cord,Lin_SCur_y_min_5)
plot(cord,Lin_SCur_y_min_6)
plot(cord,Lin_SCur_y_min_7)
plot(cord,Lin_SCur_y_min_8)
plot(cord,Lin_SCur_y_min_9)
plot(cord,Lin_SCur_y_min_10)
plot(cord,Lin_SCur_y_min_11)
plot(cord,Lin_SCur_y_min_12)
plot(cord,Lin_SCur_y_min_13)
plot(cord,Lin_SCur_y_min_14)
plot(cord,Lin_SCur_y_min_15)
plot(cord,Lin_SCur_y_min_16)
plot(cord,Lin_SCur_y_min_17)
plot(cord,Lin_SCur_y_min_18)
plot(cord,Lin_SCur_y_min_19)
plot(cord,Lin_SCur_y_min_20)

hold off
title('Minimum CF Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)

%% Mean Bending stress about y-axis (CF) along the pipeline

figure
hold on
plot(cord,Lin_SCur_y_mean_1)
plot(cord,Lin_SCur_y_mean_2)
plot(cord,Lin_SCur_y_mean_3)
plot(cord,Lin_SCur_y_mean_4)
plot(cord,Lin_SCur_y_mean_5)
plot(cord,Lin_SCur_y_mean_6)
plot(cord,Lin_SCur_y_mean_7)
plot(cord,Lin_SCur_y_mean_8)
plot(cord,Lin_SCur_y_mean_9)
plot(cord,Lin_SCur_y_mean_10)
plot(cord,Lin_SCur_y_mean_11)
plot(cord,Lin_SCur_y_mean_12)
plot(cord,Lin_SCur_y_mean_13)
plot(cord,Lin_SCur_y_mean_14)
plot(cord,Lin_SCur_y_mean_15)
plot(cord,Lin_SCur_y_mean_16)
plot(cord,Lin_SCur_y_mean_17)
plot(cord,Lin_SCur_y_mean_18)
plot(cord,Lin_SCur_y_mean_19)
plot(cord,Lin_SCur_y_mean_20)

hold off
title('Mean CF Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','east','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)
%% Maximum Bending stress about z-axis (IL) along the pipeline

figure
hold on
plot(cord,Lin_SCur_z_max_1)
plot(cord,Lin_SCur_z_max_2)
plot(cord,Lin_SCur_z_max_3)
plot(cord,Lin_SCur_z_max_4)
plot(cord,Lin_SCur_z_max_5)
plot(cord,Lin_SCur_z_max_6)
plot(cord,Lin_SCur_z_max_7)
plot(cord,Lin_SCur_z_max_8)
plot(cord,Lin_SCur_z_max_9)
plot(cord,Lin_SCur_z_max_10)
plot(cord,Lin_SCur_z_max_11)
plot(cord,Lin_SCur_z_max_12)
plot(cord,Lin_SCur_z_max_13)
plot(cord,Lin_SCur_z_max_14)
plot(cord,Lin_SCur_z_max_15)
plot(cord,Lin_SCur_z_max_16)
plot(cord,Lin_SCur_z_max_17)
plot(cord,Lin_SCur_z_max_18)
plot(cord,Lin_SCur_z_max_19)
plot(cord,Lin_SCur_z_max_20)

hold off
title('Maximum IL Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)

%% Minimum Bending stress about z-axis (IL) along the pipeline

figure
hold on
plot(cord,Lin_SCur_z_min_1)
plot(cord,Lin_SCur_z_min_2)
plot(cord,Lin_SCur_z_min_3)
plot(cord,Lin_SCur_z_min_4)
plot(cord,Lin_SCur_z_min_5)
plot(cord,Lin_SCur_z_min_6)
plot(cord,Lin_SCur_z_min_7)
plot(cord,Lin_SCur_z_min_8)
plot(cord,Lin_SCur_z_min_9)
plot(cord,Lin_SCur_z_min_10)
plot(cord,Lin_SCur_z_min_11)
plot(cord,Lin_SCur_z_min_12)
plot(cord,Lin_SCur_z_min_13)
plot(cord,Lin_SCur_z_min_14)
plot(cord,Lin_SCur_z_min_15)
plot(cord,Lin_SCur_z_min_16)
plot(cord,Lin_SCur_z_min_17)
plot(cord,Lin_SCur_z_min_18)
plot(cord,Lin_SCur_z_min_19)
plot(cord,Lin_SCur_z_min_20)

hold off
title('Minimum IL Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)

%% Mean Bending stress about z-axis (IL) along the pipeline

figure
hold on
plot(cord,Lin_SCur_z_mean_1)
plot(cord,Lin_SCur_z_mean_2)
plot(cord,Lin_SCur_z_mean_3)
plot(cord,Lin_SCur_z_mean_4)
plot(cord,Lin_SCur_z_mean_5)
plot(cord,Lin_SCur_z_mean_6)
plot(cord,Lin_SCur_z_mean_7)
plot(cord,Lin_SCur_z_mean_8)
plot(cord,Lin_SCur_z_mean_9)
plot(cord,Lin_SCur_z_mean_10)
plot(cord,Lin_SCur_z_mean_11)
plot(cord,Lin_SCur_z_mean_12)
plot(cord,Lin_SCur_z_mean_13)
plot(cord,Lin_SCur_z_mean_14)
plot(cord,Lin_SCur_z_mean_15)
plot(cord,Lin_SCur_z_mean_16)
plot(cord,Lin_SCur_z_mean_17)
plot(cord,Lin_SCur_z_mean_18)
plot(cord,Lin_SCur_z_mean_19)
plot(cord,Lin_SCur_z_mean_20)

hold off
title('Mean IL Bending Stress','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','east','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Stress [MPa]','FontSize',20)

%% One-Year CF Fatigue Damage along the pipeline

figure
hold on
plot(cord,Lin_D_SCur_y_1)
plot(cord,Lin_D_SCur_y_2)
plot(cord,Lin_D_SCur_y_3)
plot(cord,Lin_D_SCur_y_4)
plot(cord,Lin_D_SCur_y_5)
plot(cord,Lin_D_SCur_y_6)
plot(cord,Lin_D_SCur_y_7)
plot(cord,Lin_D_SCur_y_8)
plot(cord,Lin_D_SCur_y_9)
plot(cord,Lin_D_SCur_y_10)
plot(cord,Lin_D_SCur_y_11)
plot(cord,Lin_D_SCur_y_12)
plot(cord,Lin_D_SCur_y_13)
plot(cord,Lin_D_SCur_y_14)
plot(cord,Lin_D_SCur_y_15)
plot(cord,Lin_D_SCur_y_16)
plot(cord,Lin_D_SCur_y_17)
plot(cord,Lin_D_SCur_y_18)
plot(cord,Lin_D_SCur_y_19)
plot(cord,Lin_D_SCur_y_20)

hold off
title('CF Fatigue Damage','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Damage','FontSize',20)

%% One-Year IL Fatigue Damage along the pipeline

figure
hold on
plot(cord,Lin_D_SCur_z_1)
plot(cord,Lin_D_SCur_z_2)
plot(cord,Lin_D_SCur_z_3)
plot(cord,Lin_D_SCur_z_4)
plot(cord,Lin_D_SCur_z_5)
plot(cord,Lin_D_SCur_z_6)
plot(cord,Lin_D_SCur_z_7)
plot(cord,Lin_D_SCur_z_8)
plot(cord,Lin_D_SCur_z_9)
plot(cord,Lin_D_SCur_z_10)
plot(cord,Lin_D_SCur_z_11)
plot(cord,Lin_D_SCur_z_12)
plot(cord,Lin_D_SCur_z_13)
plot(cord,Lin_D_SCur_z_14)
plot(cord,Lin_D_SCur_z_15)
plot(cord,Lin_D_SCur_z_16)
plot(cord,Lin_D_SCur_z_17)
plot(cord,Lin_D_SCur_z_18)
plot(cord,Lin_D_SCur_z_19)
plot(cord,Lin_D_SCur_z_20)

hold off
title('IL Fatigue Damage','FontSize',20)
legend('0.5 m/s','0.6 m/s','0.7 m/s','0.8 m/s','0.9 m/s','1.0 m/s','1.1 m/s','1.2 m/s','1.3 m/s','1.4 m/s','1.5 m/s','1.6 m/s','1.7 m/s','1.8 m/s','1.9 m/s','2.0 m/s','2.1 m/s','2.2 m/s','2.3 m/s','2.4 m/s','location','best','FontSize',15)
xlabel('Position [m]','FontSize',20)
ylabel('Damage','FontSize',20)
