clc
clear all
close all

%% Note !!!!! After finishing post-processing using this script Save!!!
%% the workspace as 'Lin_Displacement_post_processed.mat'. It will be used
%% afterwards for the comparative study

%% Loading displacement data for the 20 examined current velocities
Lin_R1 = load('sima_noddis_1.asc', '-ascii');
Lin_R2 = load('sima_noddis_2.asc', '-ascii');
Lin_R3 = load('sima_noddis_3.asc', '-ascii');
Lin_R4 = load('sima_noddis_4.asc', '-ascii');
Lin_R5 = load('sima_noddis_5.asc', '-ascii');
Lin_R6 = load('sima_noddis_6.asc', '-ascii');
Lin_R7 = load('sima_noddis_7.asc', '-ascii');
Lin_R8 = load('sima_noddis_8.asc', '-ascii');
Lin_R9 = load('sima_noddis_9.asc', '-ascii');
Lin_R10 = load('sima_noddis_10.asc', '-ascii');
Lin_R11 = load('sima_noddis_11.asc', '-ascii');
Lin_R12 = load('sima_noddis_12.asc', '-ascii');
Lin_R13 = load('sima_noddis_13.asc', '-ascii');
Lin_R14 = load('sima_noddis_14.asc', '-ascii');
Lin_R15 = load('sima_noddis_15.asc', '-ascii');
Lin_R16 = load('sima_noddis_16.asc', '-ascii');
Lin_R17 = load('sima_noddis_17.asc', '-ascii');
Lin_R18 = load('sima_noddis_18.asc', '-ascii');
Lin_R19 = load('sima_noddis_19.asc', '-ascii');
Lin_R20 = load('sima_noddis_20.asc', '-ascii');
 
%% Load Static Configuration
Lin_Static_yz = load('Lin_Static_yz.asc', '-ascii');

%% Removing transient
Lin_R1(1:23999,:)=[];
Lin_R2(1:23999,:)=[];
Lin_R3(1:23999,:)=[];
Lin_R4(1:23999,:)=[];
Lin_R5(1:23999,:)=[];
Lin_R6(1:23999,:)=[];
Lin_R7(1:23999,:)=[];
Lin_R8(1:23999,:)=[];
Lin_R9(1:23999,:)=[];
Lin_R10(1:23999,:)=[];
% Lin_R11(1:23999,:)=[];
Lin_R11(1:69999,:)=[];% a smaller timestep was used for this velocity
Lin_R12(1:23999,:)=[];
Lin_R13(1:23999,:)=[];
Lin_R14(1:23999,:)=[];
Lin_R15(1:23999,:)=[];
Lin_R16(1:23999,:)=[];
Lin_R17(1:23999,:)=[];
Lin_R18(1:23999,:)=[];
Lin_R19(1:23999,:)=[];
Lin_R20(1:23999,:)=[];

%% IL Response
% Time series of IL Displacement
for n=1:(length(Lin_R1(1,:))-1)/3 
    counter=3*n;
Lin_Res_y_1(:,n)=Lin_R1(:,counter);
Lin_Res_y_2(:,n)=Lin_R2(:,counter);
Lin_Res_y_3(:,n)=Lin_R3(:,counter);
Lin_Res_y_4(:,n)=Lin_R4(:,counter);
Lin_Res_y_5(:,n)=Lin_R5(:,counter);
Lin_Res_y_6(:,n)=Lin_R6(:,counter);
Lin_Res_y_7(:,n)=Lin_R7(:,counter);
Lin_Res_y_8(:,n)=Lin_R8(:,counter);
Lin_Res_y_9(:,n)=Lin_R9(:,counter);
Lin_Res_y_10(:,n)=Lin_R10(:,counter);
Lin_Res_y_11(:,n)=Lin_R11(:,counter);
Lin_Res_y_12(:,n)=Lin_R12(:,counter);
Lin_Res_y_13(:,n)=Lin_R13(:,counter);
Lin_Res_y_14(:,n)=Lin_R14(:,counter);
Lin_Res_y_15(:,n)=Lin_R15(:,counter);
Lin_Res_y_16(:,n)=Lin_R16(:,counter);
Lin_Res_y_17(:,n)=Lin_R17(:,counter);
Lin_Res_y_18(:,n)=Lin_R18(:,counter);
Lin_Res_y_19(:,n)=Lin_R19(:,counter);
Lin_Res_y_20(:,n)=Lin_R20(:,counter);
end

%%
% Removing overlapping nodes
Lin_Res_y_1=[Lin_Res_y_1(:,1:61),Lin_Res_y_1(:,63:82),Lin_Res_y_1(:,84:97),Lin_Res_y_1(:,99:118),Lin_Res_y_1(:,120:179)];
Lin_Res_y_2=[Lin_Res_y_2(:,1:61),Lin_Res_y_2(:,63:82),Lin_Res_y_2(:,84:97),Lin_Res_y_2(:,99:118),Lin_Res_y_2(:,120:179)];
Lin_Res_y_3=[Lin_Res_y_3(:,1:61),Lin_Res_y_3(:,63:82),Lin_Res_y_3(:,84:97),Lin_Res_y_3(:,99:118),Lin_Res_y_3(:,120:179)];
Lin_Res_y_4=[Lin_Res_y_4(:,1:61),Lin_Res_y_4(:,63:82),Lin_Res_y_4(:,84:97),Lin_Res_y_4(:,99:118),Lin_Res_y_4(:,120:179)];
Lin_Res_y_5=[Lin_Res_y_5(:,1:61),Lin_Res_y_5(:,63:82),Lin_Res_y_5(:,84:97),Lin_Res_y_5(:,99:118),Lin_Res_y_5(:,120:179)];
Lin_Res_y_6=[Lin_Res_y_6(:,1:61),Lin_Res_y_6(:,63:82),Lin_Res_y_6(:,84:97),Lin_Res_y_6(:,99:118),Lin_Res_y_6(:,120:179)];
Lin_Res_y_7=[Lin_Res_y_7(:,1:61),Lin_Res_y_7(:,63:82),Lin_Res_y_7(:,84:97),Lin_Res_y_7(:,99:118),Lin_Res_y_7(:,120:179)];
Lin_Res_y_8=[Lin_Res_y_8(:,1:61),Lin_Res_y_8(:,63:82),Lin_Res_y_8(:,84:97),Lin_Res_y_8(:,99:118),Lin_Res_y_8(:,120:179)];
Lin_Res_y_9=[Lin_Res_y_9(:,1:61),Lin_Res_y_9(:,63:82),Lin_Res_y_9(:,84:97),Lin_Res_y_9(:,99:118),Lin_Res_y_9(:,120:179)];
Lin_Res_y_10=[Lin_Res_y_10(:,1:61),Lin_Res_y_10(:,63:82),Lin_Res_y_10(:,84:97),Lin_Res_y_10(:,99:118),Lin_Res_y_10(:,120:179)];
Lin_Res_y_11=[Lin_Res_y_11(:,1:61),Lin_Res_y_11(:,63:82),Lin_Res_y_11(:,84:97),Lin_Res_y_11(:,99:118),Lin_Res_y_11(:,120:179)];
Lin_Res_y_12=[Lin_Res_y_12(:,1:61),Lin_Res_y_12(:,63:82),Lin_Res_y_12(:,84:97),Lin_Res_y_12(:,99:118),Lin_Res_y_12(:,120:179)];
Lin_Res_y_13=[Lin_Res_y_13(:,1:61),Lin_Res_y_13(:,63:82),Lin_Res_y_13(:,84:97),Lin_Res_y_13(:,99:118),Lin_Res_y_13(:,120:179)];
Lin_Res_y_14=[Lin_Res_y_14(:,1:61),Lin_Res_y_14(:,63:82),Lin_Res_y_14(:,84:97),Lin_Res_y_14(:,99:118),Lin_Res_y_14(:,120:179)];
Lin_Res_y_15=[Lin_Res_y_15(:,1:61),Lin_Res_y_15(:,63:82),Lin_Res_y_15(:,84:97),Lin_Res_y_15(:,99:118),Lin_Res_y_15(:,120:179)];
Lin_Res_y_16=[Lin_Res_y_16(:,1:61),Lin_Res_y_16(:,63:82),Lin_Res_y_16(:,84:97),Lin_Res_y_16(:,99:118),Lin_Res_y_16(:,120:179)];
Lin_Res_y_17=[Lin_Res_y_17(:,1:61),Lin_Res_y_17(:,63:82),Lin_Res_y_17(:,84:97),Lin_Res_y_17(:,99:118),Lin_Res_y_17(:,120:179)];
Lin_Res_y_18=[Lin_Res_y_18(:,1:61),Lin_Res_y_18(:,63:82),Lin_Res_y_18(:,84:97),Lin_Res_y_18(:,99:118),Lin_Res_y_18(:,120:179)];
Lin_Res_y_19=[Lin_Res_y_19(:,1:61),Lin_Res_y_19(:,63:82),Lin_Res_y_19(:,84:97),Lin_Res_y_19(:,99:118),Lin_Res_y_19(:,120:179)];
Lin_Res_y_20=[Lin_Res_y_20(:,1:61),Lin_Res_y_20(:,63:82),Lin_Res_y_20(:,84:97),Lin_Res_y_20(:,99:118),Lin_Res_y_20(:,120:179)];


%% CF Response
% Time series of CF Displacement
for n=1:(length(Lin_R1(1,:))-1)/3 
    counter=3*n+1;
Lin_Res_z_1(:,n)=Lin_R1(:,counter);
Lin_Res_z_2(:,n)=Lin_R2(:,counter);
Lin_Res_z_3(:,n)=Lin_R3(:,counter);
Lin_Res_z_4(:,n)=Lin_R4(:,counter);
Lin_Res_z_5(:,n)=Lin_R5(:,counter);
Lin_Res_z_6(:,n)=Lin_R6(:,counter);
Lin_Res_z_7(:,n)=Lin_R7(:,counter);
Lin_Res_z_8(:,n)=Lin_R8(:,counter);
Lin_Res_z_9(:,n)=Lin_R9(:,counter);
Lin_Res_z_10(:,n)=Lin_R10(:,counter);
Lin_Res_z_11(:,n)=Lin_R11(:,counter);
Lin_Res_z_12(:,n)=Lin_R12(:,counter);
Lin_Res_z_13(:,n)=Lin_R13(:,counter);
Lin_Res_z_14(:,n)=Lin_R14(:,counter);
Lin_Res_z_15(:,n)=Lin_R15(:,counter);
Lin_Res_z_16(:,n)=Lin_R16(:,counter);
Lin_Res_z_17(:,n)=Lin_R17(:,counter);
Lin_Res_z_18(:,n)=Lin_R18(:,counter);
Lin_Res_z_19(:,n)=Lin_R19(:,counter);
Lin_Res_z_20(:,n)=Lin_R20(:,counter);
end

%%
% Removing overlapping nodes
Lin_Res_z_1=[Lin_Res_z_1(:,1:61),Lin_Res_z_1(:,63:82),Lin_Res_z_1(:,84:97),Lin_Res_z_1(:,99:118),Lin_Res_z_1(:,120:179)];
Lin_Res_z_2=[Lin_Res_z_2(:,1:61),Lin_Res_z_2(:,63:82),Lin_Res_z_2(:,84:97),Lin_Res_z_2(:,99:118),Lin_Res_z_2(:,120:179)];
Lin_Res_z_3=[Lin_Res_z_3(:,1:61),Lin_Res_z_3(:,63:82),Lin_Res_z_3(:,84:97),Lin_Res_z_3(:,99:118),Lin_Res_z_3(:,120:179)];
Lin_Res_z_4=[Lin_Res_z_4(:,1:61),Lin_Res_z_4(:,63:82),Lin_Res_z_4(:,84:97),Lin_Res_z_4(:,99:118),Lin_Res_z_4(:,120:179)];
Lin_Res_z_5=[Lin_Res_z_5(:,1:61),Lin_Res_z_5(:,63:82),Lin_Res_z_5(:,84:97),Lin_Res_z_5(:,99:118),Lin_Res_z_5(:,120:179)];
Lin_Res_z_6=[Lin_Res_z_6(:,1:61),Lin_Res_z_6(:,63:82),Lin_Res_z_6(:,84:97),Lin_Res_z_6(:,99:118),Lin_Res_z_6(:,120:179)];
Lin_Res_z_7=[Lin_Res_z_7(:,1:61),Lin_Res_z_7(:,63:82),Lin_Res_z_7(:,84:97),Lin_Res_z_7(:,99:118),Lin_Res_z_7(:,120:179)];
Lin_Res_z_8=[Lin_Res_z_8(:,1:61),Lin_Res_z_8(:,63:82),Lin_Res_z_8(:,84:97),Lin_Res_z_8(:,99:118),Lin_Res_z_8(:,120:179)];
Lin_Res_z_9=[Lin_Res_z_9(:,1:61),Lin_Res_z_9(:,63:82),Lin_Res_z_9(:,84:97),Lin_Res_z_9(:,99:118),Lin_Res_z_9(:,120:179)];
Lin_Res_z_10=[Lin_Res_z_10(:,1:61),Lin_Res_z_10(:,63:82),Lin_Res_z_10(:,84:97),Lin_Res_z_10(:,99:118),Lin_Res_z_10(:,120:179)];
Lin_Res_z_11=[Lin_Res_z_11(:,1:61),Lin_Res_z_11(:,63:82),Lin_Res_z_11(:,84:97),Lin_Res_z_11(:,99:118),Lin_Res_z_11(:,120:179)];
Lin_Res_z_12=[Lin_Res_z_12(:,1:61),Lin_Res_z_12(:,63:82),Lin_Res_z_12(:,84:97),Lin_Res_z_12(:,99:118),Lin_Res_z_12(:,120:179)];
Lin_Res_z_13=[Lin_Res_z_13(:,1:61),Lin_Res_z_13(:,63:82),Lin_Res_z_13(:,84:97),Lin_Res_z_13(:,99:118),Lin_Res_z_13(:,120:179)];
Lin_Res_z_14=[Lin_Res_z_14(:,1:61),Lin_Res_z_14(:,63:82),Lin_Res_z_14(:,84:97),Lin_Res_z_14(:,99:118),Lin_Res_z_14(:,120:179)];
Lin_Res_z_15=[Lin_Res_z_15(:,1:61),Lin_Res_z_15(:,63:82),Lin_Res_z_15(:,84:97),Lin_Res_z_15(:,99:118),Lin_Res_z_15(:,120:179)];
Lin_Res_z_16=[Lin_Res_z_16(:,1:61),Lin_Res_z_16(:,63:82),Lin_Res_z_16(:,84:97),Lin_Res_z_16(:,99:118),Lin_Res_z_16(:,120:179)];
Lin_Res_z_17=[Lin_Res_z_17(:,1:61),Lin_Res_z_17(:,63:82),Lin_Res_z_17(:,84:97),Lin_Res_z_17(:,99:118),Lin_Res_z_17(:,120:179)];
Lin_Res_z_18=[Lin_Res_z_18(:,1:61),Lin_Res_z_18(:,63:82),Lin_Res_z_18(:,84:97),Lin_Res_z_18(:,99:118),Lin_Res_z_18(:,120:179)];
Lin_Res_z_19=[Lin_Res_z_19(:,1:61),Lin_Res_z_19(:,63:82),Lin_Res_z_19(:,84:97),Lin_Res_z_19(:,99:118),Lin_Res_z_19(:,120:179)];
Lin_Res_z_20=[Lin_Res_z_20(:,1:61),Lin_Res_z_20(:,63:82),Lin_Res_z_20(:,84:97),Lin_Res_z_20(:,99:118),Lin_Res_z_20(:,120:179)];

%%
%% General Input
D=0.702;                        % Hydrodynamic Diameter [m]
Ds=0.61;                        % Steel Pipe Diameter [m]
L=114;                          %Length [m]
nnod=length(Lin_Res_y_1(1,:));  %Number of nodes
cord(1:61)=0:30/60:30;          %Length coordinates along the pipe
cord(61:81)=30:20.25/20:50.25;
cord(81:95)=50.25:13.5/14:63.75;
cord(95:115)=63.75:20.25/20:84;
cord(115:175)=84:30/60:114;
t11=Lin_R11(:,1)-Lin_R11(1,1);  %Time vector for the special case
ns11=length(t11);               %Number of data points for the special case
dt11=t11(2)-t11(1);             %Time step of sample for the special case
Fs11=1/dt11;                    %Sampling frequency for the special case

t=Lin_R1(:,1)-Lin_R1(1,1);      %Time vector
ns=length(t);                   %Number of data points
dt=t(2)-t(1);                   %Time step of sample
Fs=1/dt;                        %Sampling frequency
u_cur=0.5:0.1:2.4;              %Current velocities

%% Seafloor Configurations
Lin_Seafloor_disp = load('Lin_Seafloor_disp.asc', '-ascii');
Lin_Seafloor_z_initial=zeros(1,175);
Lin_Seafloor_x_initial=cord;
Lin_Seafloor_z_initial(1:61)=-399.8;
Lin_Seafloor_z_initial(62:114)=-401.0;
Lin_Seafloor_z_initial(115:175)=-399.8;
Lin_Seafloor_x_final=zeros(20,175);
Lin_Seafloor_z_final=zeros(20,175);
for n=1:20
    counter=2*n-1;
    Lin_Seafloor_x_final(n,:)=Lin_Seafloor_x_initial+Lin_Seafloor_disp(:,counter)';
end
for n=1:20
    counter=2*n;
    Lin_Seafloor_z_final(n,:)=Lin_Seafloor_z_initial-Lin_Seafloor_disp(:,counter)';
    Lin_Seafloor_z_final(n,61)=Lin_Static_yz(61,counter)';
end


%%
%% Remove Static Configuration of IL Displacement (not used in the analysis)
%     for n=1:nnod
%         Lin_Res_y_1(:,n)=Lin_Res_y_1(:,n)-Lin_Static_yz(n,1);
%         Lin_Res_y_2(:,n)=Lin_Res_y_2(:,n)-Lin_Static_yz(n,3);
%         Lin_Res_y_3(:,n)=Lin_Res_y_3(:,n)-Lin_Static_yz(n,5);
%         Lin_Res_y_4(:,n)=Lin_Res_y_4(:,n)-Lin_Static_yz(n,7);
%         Lin_Res_y_5(:,n)=Lin_Res_y_5(:,n)-Lin_Static_yz(n,9);
%         Lin_Res_y_6(:,n)=Lin_Res_y_6(:,n)-Lin_Static_yz(n,11);
%         Lin_Res_y_7(:,n)=Lin_Res_y_7(:,n)-Lin_Static_yz(n,13);
%         Lin_Res_y_8(:,n)=Lin_Res_y_8(:,n)-Lin_Static_yz(n,15);
%         Lin_Res_y_9(:,n)=Lin_Res_y_9(:,n)-Lin_Static_yz(n,17);
%         Lin_Res_y_10(:,n)=Lin_Res_y_10(:,n)-Lin_Static_yz(n,19);
%         Lin_Res_y_11(:,n)=Lin_Res_y_11(:,n)-Lin_Static_yz(n,21);
%         Lin_Res_y_12(:,n)=Lin_Res_y_12(:,n)-Lin_Static_yz(n,23);
%         Lin_Res_y_13(:,n)=Lin_Res_y_13(:,n)-Lin_Static_yz(n,25);
%         Lin_Res_y_14(:,n)=Lin_Res_y_14(:,n)-Lin_Static_yz(n,27);
%         Lin_Res_y_15(:,n)=Lin_Res_y_15(:,n)-Lin_Static_yz(n,29);
%         Lin_Res_y_16(:,n)=Lin_Res_y_16(:,n)-Lin_Static_yz(n,31);
%         Lin_Res_y_17(:,n)=Lin_Res_y_17(:,n)-Lin_Static_yz(n,33);
%         Lin_Res_y_18(:,n)=Lin_Res_y_18(:,n)-Lin_Static_yz(n,35);
%         Lin_Res_y_19(:,n)=Lin_Res_y_19(:,n)-Lin_Static_yz(n,37);
%         Lin_Res_y_20(:,n)=Lin_Res_y_20(:,n)-Lin_Static_yz(n,39);       
%     end
    
        %%
%% Remove Static Configuration of CF Displacement (not used in the analysis)
%     for n=1:nnod
%         Lin_Res_z_1(:,n)=Lin_Res_z_1(:,n)-Lin_Static_yz(n,2);
%         Lin_Res_z_2(:,n)=Lin_Res_z_2(:,n)-Lin_Static_yz(n,4);
%         Lin_Res_z_3(:,n)=Lin_Res_z_3(:,n)-Lin_Static_yz(n,6);
%         Lin_Res_z_4(:,n)=Lin_Res_z_4(:,n)-Lin_Static_yz(n,8);
%         Lin_Res_z_5(:,n)=Lin_Res_z_5(:,n)-Lin_Static_yz(n,10);
%         Lin_Res_z_6(:,n)=Lin_Res_z_6(:,n)-Lin_Static_yz(n,12);
%         Lin_Res_z_7(:,n)=Lin_Res_z_7(:,n)-Lin_Static_yz(n,14);
%         Lin_Res_z_8(:,n)=Lin_Res_z_8(:,n)-Lin_Static_yz(n,16);
%         Lin_Res_z_9(:,n)=Lin_Res_z_9(:,n)-Lin_Static_yz(n,18);
%         Lin_Res_z_10(:,n)=Lin_Res_z_10(:,n)-Lin_Static_yz(n,20);
%         Lin_Res_z_11(:,n)=Lin_Res_z_11(:,n)-Lin_Static_yz(n,22);
%         Lin_Res_z_12(:,n)=Lin_Res_z_12(:,n)-Lin_Static_yz(n,24);
%         Lin_Res_z_13(:,n)=Lin_Res_z_13(:,n)-Lin_Static_yz(n,26);
%         Lin_Res_z_14(:,n)=Lin_Res_z_14(:,n)-Lin_Static_yz(n,28);
%         Lin_Res_z_15(:,n)=Lin_Res_z_15(:,n)-Lin_Static_yz(n,30);
%         Lin_Res_z_16(:,n)=Lin_Res_z_16(:,n)-Lin_Static_yz(n,32);
%         Lin_Res_z_17(:,n)=Lin_Res_z_17(:,n)-Lin_Static_yz(n,34);
%         Lin_Res_z_18(:,n)=Lin_Res_z_18(:,n)-Lin_Static_yz(n,36);
%         Lin_Res_z_19(:,n)=Lin_Res_z_19(:,n)-Lin_Static_yz(n,38);
%         Lin_Res_z_20(:,n)=Lin_Res_z_20(:,n)-Lin_Static_yz(n,40);
%     end

%% Finding maximum response amplitudes Amax in the IL direction
Lin_A_y_max=zeros(1,20);
Lin_Index=zeros(1,20);
[Lin_A_y_max(1),Lin_Index(1)]=max((max(Lin_Res_y_1(:,:))-min(Lin_Res_y_1(:,:)))/2);
[Lin_A_y_max(2),Lin_Index(2)]=max((max(Lin_Res_y_2(:,:))-min(Lin_Res_y_2(:,:)))/2);
[Lin_A_y_max(3),Lin_Index(3)]=max((max(Lin_Res_y_3(:,:))-min(Lin_Res_y_3(:,:)))/2);
[Lin_A_y_max(4),Lin_Index(4)]=max((max(Lin_Res_y_4(:,:))-min(Lin_Res_y_4(:,:)))/2);
[Lin_A_y_max(5),Lin_Index(5)]=max((max(Lin_Res_y_5(:,:))-min(Lin_Res_y_5(:,:)))/2);
[Lin_A_y_max(6),Lin_Index(6)]=max((max(Lin_Res_y_6(:,:))-min(Lin_Res_y_6(:,:)))/2);
[Lin_A_y_max(7),Lin_Index(7)]=max((max(Lin_Res_y_7(:,:))-min(Lin_Res_y_7(:,:)))/2);
[Lin_A_y_max(8),Lin_Index(8)]=max((max(Lin_Res_y_8(:,:))-min(Lin_Res_y_8(:,:)))/2);
[Lin_A_y_max(9),Lin_Index(9)]=max((max(Lin_Res_y_9(:,:))-min(Lin_Res_y_9(:,:)))/2);
[Lin_A_y_max(10),Lin_Index(10)]=max((max(Lin_Res_y_10(:,:))-min(Lin_Res_y_10(:,:)))/2);
[Lin_A_y_max(11),Lin_Index(11)]=max((max(Lin_Res_y_11(:,:))-min(Lin_Res_y_11(:,:)))/2);
[Lin_A_y_max(12),Lin_Index(12)]=max((max(Lin_Res_y_12(:,:))-min(Lin_Res_y_12(:,:)))/2);
[Lin_A_y_max(13),Lin_Index(13)]=max((max(Lin_Res_y_13(:,:))-min(Lin_Res_y_13(:,:)))/2);
[Lin_A_y_max(14),Lin_Index(14)]=max((max(Lin_Res_y_14(:,:))-min(Lin_Res_y_14(:,:)))/2);
[Lin_A_y_max(15),Lin_Index(15)]=max((max(Lin_Res_y_15(:,:))-min(Lin_Res_y_15(:,:)))/2);
[Lin_A_y_max(16),Lin_Index(16)]=max((max(Lin_Res_y_16(:,:))-min(Lin_Res_y_16(:,:)))/2);
[Lin_A_y_max(17),Lin_Index(17)]=max((max(Lin_Res_y_17(:,:))-min(Lin_Res_y_17(:,:)))/2);
[Lin_A_y_max(18),Lin_Index(18)]=max((max(Lin_Res_y_18(:,:))-min(Lin_Res_y_18(:,:)))/2);
[Lin_A_y_max(19),Lin_Index(19)]=max((max(Lin_Res_y_19(:,:))-min(Lin_Res_y_19(:,:)))/2);
[Lin_A_y_max(20),Lin_Index(20)]=max((max(Lin_Res_y_20(:,:))-min(Lin_Res_y_20(:,:)))/2);

%% Finding maximum response amplitudes Amax in the CF direction
Lin_A_z_max=zeros(1,20);
Lin_Index_z=zeros(1,20);
[Lin_A_z_max(1),Lin_Index_z(1)]=max((max(Lin_Res_z_1(:,:))-min(Lin_Res_z_1(:,:)))/2);
[Lin_A_z_max(2),Lin_Index_z(2)]=max((max(Lin_Res_z_2(:,:))-min(Lin_Res_z_2(:,:)))/2);
[Lin_A_z_max(3),Lin_Index_z(3)]=max((max(Lin_Res_z_3(:,:))-min(Lin_Res_z_3(:,:)))/2);
[Lin_A_z_max(4),Lin_Index_z(4)]=max((max(Lin_Res_z_4(:,:))-min(Lin_Res_z_4(:,:)))/2);
[Lin_A_z_max(5),Lin_Index_z(5)]=max((max(Lin_Res_z_5(:,:))-min(Lin_Res_z_5(:,:)))/2);
[Lin_A_z_max(6),Lin_Index_z(6)]=max((max(Lin_Res_z_6(:,:))-min(Lin_Res_z_6(:,:)))/2);
[Lin_A_z_max(7),Lin_Index_z(7)]=max((max(Lin_Res_z_7(:,:))-min(Lin_Res_z_7(:,:)))/2);
[Lin_A_z_max(8),Lin_Index_z(8)]=max((max(Lin_Res_z_8(:,:))-min(Lin_Res_z_8(:,:)))/2);
[Lin_A_z_max(9),Lin_Index_z(9)]=max((max(Lin_Res_z_9(:,:))-min(Lin_Res_z_9(:,:)))/2);
[Lin_A_z_max(10),Lin_Index_z(10)]=max((max(Lin_Res_z_10(:,:))-min(Lin_Res_z_10(:,:)))/2);
[Lin_A_z_max(11),Lin_Index_z(11)]=max((max(Lin_Res_z_11(:,:))-min(Lin_Res_z_11(:,:)))/2);
[Lin_A_z_max(12),Lin_Index_z(12)]=max((max(Lin_Res_z_12(:,:))-min(Lin_Res_z_12(:,:)))/2);
[Lin_A_z_max(13),Lin_Index_z(13)]=max((max(Lin_Res_z_13(:,:))-min(Lin_Res_z_13(:,:)))/2);
[Lin_A_z_max(14),Lin_Index_z(14)]=max((max(Lin_Res_z_14(:,:))-min(Lin_Res_z_14(:,:)))/2);
[Lin_A_z_max(15),Lin_Index_z(15)]=max((max(Lin_Res_z_15(:,:))-min(Lin_Res_z_15(:,:)))/2);
[Lin_A_z_max(16),Lin_Index_z(16)]=max((max(Lin_Res_z_16(:,:))-min(Lin_Res_z_16(:,:)))/2);
[Lin_A_z_max(17),Lin_Index_z(17)]=max((max(Lin_Res_z_17(:,:))-min(Lin_Res_z_17(:,:)))/2);
[Lin_A_z_max(18),Lin_Index_z(18)]=max((max(Lin_Res_z_18(:,:))-min(Lin_Res_z_18(:,:)))/2);
[Lin_A_z_max(19),Lin_Index_z(19)]=max((max(Lin_Res_z_19(:,:))-min(Lin_Res_z_19(:,:)))/2);
[Lin_A_z_max(20),Lin_Index_z(20)]=max((max(Lin_Res_z_20(:,:))-min(Lin_Res_z_20(:,:)))/2);


%% Calculation of spectra

% IL response (displacement) of the node the maximum response amplitude

% Matrix with the time steps and the respective IL responses
Lin_resp_y_1=[t Lin_Res_y_1(:,Lin_Index(1))];
Lin_resp_y_2=[t Lin_Res_y_2(:,Lin_Index(2))];
Lin_resp_y_3=[t Lin_Res_y_3(:,Lin_Index(3))];
Lin_resp_y_4=[t Lin_Res_y_4(:,Lin_Index(4))];
Lin_resp_y_5=[t Lin_Res_y_5(:,Lin_Index(5))];
Lin_resp_y_6=[t Lin_Res_y_6(:,Lin_Index(6))];
Lin_resp_y_7=[t Lin_Res_y_7(:,Lin_Index(7))];
Lin_resp_y_8=[t Lin_Res_y_8(:,Lin_Index(8))];
Lin_resp_y_9=[t Lin_Res_y_9(:,Lin_Index(9))];
Lin_resp_y_10=[t Lin_Res_y_10(:,Lin_Index(10))];
Lin_resp_y_11=[t11 Lin_Res_y_11(:,Lin_Index(11))];
Lin_resp_y_12=[t Lin_Res_y_12(:,Lin_Index(12))];
Lin_resp_y_13=[t Lin_Res_y_13(:,Lin_Index(13))];
Lin_resp_y_14=[t Lin_Res_y_14(:,Lin_Index(14))];
Lin_resp_y_15=[t Lin_Res_y_15(:,Lin_Index(15))];
Lin_resp_y_16=[t Lin_Res_y_16(:,Lin_Index(16))];
Lin_resp_y_17=[t Lin_Res_y_17(:,Lin_Index(17))];
Lin_resp_y_18=[t Lin_Res_y_18(:,Lin_Index(18))];
Lin_resp_y_19=[t Lin_Res_y_19(:,Lin_Index(19))];
Lin_resp_y_20=[t Lin_Res_y_20(:,Lin_Index(20))];

% Structure to be used in WAFO

Lin_Sp_y_1=dat2spec(Lin_resp_y_1,1000);
Lin_Sp_y_2=dat2spec(Lin_resp_y_2,1000);
Lin_Sp_y_3=dat2spec(Lin_resp_y_3,1000);
Lin_Sp_y_4=dat2spec(Lin_resp_y_4,1000);
Lin_Sp_y_5=dat2spec(Lin_resp_y_5,1000);
Lin_Sp_y_6=dat2spec(Lin_resp_y_6,1000);
Lin_Sp_y_7=dat2spec(Lin_resp_y_7,1000);
Lin_Sp_y_8=dat2spec(Lin_resp_y_8,1000);
Lin_Sp_y_9=dat2spec(Lin_resp_y_9,1000);
Lin_Sp_y_10=dat2spec(Lin_resp_y_10,1000);
Lin_Sp_y_11=dat2spec(Lin_resp_y_11,1000);
Lin_Sp_y_12=dat2spec(Lin_resp_y_12,1000);
Lin_Sp_y_13=dat2spec(Lin_resp_y_13,1000);
Lin_Sp_y_14=dat2spec(Lin_resp_y_14,1000);
Lin_Sp_y_15=dat2spec(Lin_resp_y_15,1000);
Lin_Sp_y_16=dat2spec(Lin_resp_y_16,1000);
Lin_Sp_y_17=dat2spec(Lin_resp_y_17,1000);
Lin_Sp_y_18=dat2spec(Lin_resp_y_18,1000);
Lin_Sp_y_19=dat2spec(Lin_resp_y_19,1000);
Lin_Sp_y_20=dat2spec(Lin_resp_y_20,1000);


% Response Spectra of the IL Response Calculated using WAFO

Lin_Spec_y_1=Lin_Sp_y_1.S*2*pi; 
Lin_Spec_y_2=Lin_Sp_y_2.S*2*pi;
Lin_Spec_y_3=Lin_Sp_y_3.S*2*pi;
Lin_Spec_y_4=Lin_Sp_y_4.S*2*pi;
Lin_Spec_y_5=Lin_Sp_y_5.S*2*pi;
Lin_Spec_y_6=Lin_Sp_y_6.S*2*pi;
Lin_Spec_y_7=Lin_Sp_y_7.S*2*pi;
Lin_Spec_y_8=Lin_Sp_y_8.S*2*pi;
Lin_Spec_y_9=Lin_Sp_y_9.S*2*pi;
Lin_Spec_y_10=Lin_Sp_y_10.S*2*pi;
Lin_Spec_y_11=Lin_Sp_y_11.S*2*pi;
Lin_Spec_y_12=Lin_Sp_y_12.S*2*pi;
Lin_Spec_y_13=Lin_Sp_y_13.S*2*pi;
Lin_Spec_y_14=Lin_Sp_y_14.S*2*pi;
Lin_Spec_y_15=Lin_Sp_y_15.S*2*pi;
Lin_Spec_y_16=Lin_Sp_y_16.S*2*pi;
Lin_Spec_y_17=Lin_Sp_y_17.S*2*pi;
Lin_Spec_y_18=Lin_Sp_y_18.S*2*pi;
Lin_Spec_y_19=Lin_Sp_y_19.S*2*pi;
Lin_Spec_y_20=Lin_Sp_y_20.S*2*pi;

% Frequencies of the IL Response calculated using WAFO

Lin_Freq_y_1=Lin_Sp_y_1.w/(2*pi);
Lin_Freq_y_2=Lin_Sp_y_2.w/(2*pi);
Lin_Freq_y_3=Lin_Sp_y_3.w/(2*pi);
Lin_Freq_y_4=Lin_Sp_y_4.w/(2*pi);
Lin_Freq_y_5=Lin_Sp_y_5.w/(2*pi);
Lin_Freq_y_6=Lin_Sp_y_6.w/(2*pi);
Lin_Freq_y_7=Lin_Sp_y_7.w/(2*pi);
Lin_Freq_y_8=Lin_Sp_y_8.w/(2*pi);
Lin_Freq_y_9=Lin_Sp_y_9.w/(2*pi);
Lin_Freq_y_10=Lin_Sp_y_10.w/(2*pi);
Lin_Freq_y_11=Lin_Sp_y_11.w/(2*pi);
Lin_Freq_y_12=Lin_Sp_y_12.w/(2*pi);
Lin_Freq_y_13=Lin_Sp_y_13.w/(2*pi);
Lin_Freq_y_14=Lin_Sp_y_14.w/(2*pi);
Lin_Freq_y_15=Lin_Sp_y_15.w/(2*pi);
Lin_Freq_y_16=Lin_Sp_y_16.w/(2*pi);
Lin_Freq_y_17=Lin_Sp_y_17.w/(2*pi);
Lin_Freq_y_18=Lin_Sp_y_18.w/(2*pi);
Lin_Freq_y_19=Lin_Sp_y_19.w/(2*pi);
Lin_Freq_y_20=Lin_Sp_y_20.w/(2*pi);

%Finding the peak frequency of the IL Response
[Lin_Mx1,Lin_Ix1]=max(Lin_Spec_y_1(:));
[Lin_Mx2,Lin_Ix2]=max(Lin_Spec_y_2(:));
[Lin_Mx3,Lin_Ix3]=max(Lin_Spec_y_3(:));
[Lin_Mx4,Lin_Ix4]=max(Lin_Spec_y_4(:));
[Lin_Mx5,Lin_Ix5]=max(Lin_Spec_y_5(:));
[Lin_Mx6,Lin_Ix6]=max(Lin_Spec_y_6(:));
[Lin_Mx7,Lin_Ix7]=max(Lin_Spec_y_7(:));
[Lin_Mx8,Lin_Ix8]=max(Lin_Spec_y_8(:));
[Lin_Mx9,Lin_Ix9]=max(Lin_Spec_y_9(:));
[Lin_Mx10,Lin_Ix10]=max(Lin_Spec_y_10(:));
[Lin_Mx11,Lin_Ix11]=max(Lin_Spec_y_11(:));
[Lin_Mx12,Lin_Ix12]=max(Lin_Spec_y_12(:));
[Lin_Mx13,Lin_Ix13]=max(Lin_Spec_y_13(:));
[Lin_Mx14,Lin_Ix14]=max(Lin_Spec_y_14(:));
[Lin_Mx15,Lin_Ix15]=max(Lin_Spec_y_15(:));
[Lin_Mx16,Lin_Ix16]=max(Lin_Spec_y_16(:));
[Lin_Mx17,Lin_Ix17]=max(Lin_Spec_y_17(:));
[Lin_Mx18,Lin_Ix18]=max(Lin_Spec_y_18(:));
[Lin_Mx19,Lin_Ix19]=max(Lin_Spec_y_19(:));
[Lin_Mx20,Lin_Ix20]=max(Lin_Spec_y_20(:));


Lin_fun_freq_y=zeros(20,1);
Lin_fun_freq_y(1)=Lin_Freq_y_1(Lin_Ix1);
Lin_fun_freq_y(2)=Lin_Freq_y_2(Lin_Ix2);
Lin_fun_freq_y(3)=Lin_Freq_y_3(Lin_Ix3);
Lin_fun_freq_y(4)=Lin_Freq_y_4(Lin_Ix4);
Lin_fun_freq_y(5)=Lin_Freq_y_5(Lin_Ix5);
Lin_fun_freq_y(6)=Lin_Freq_y_6(Lin_Ix6);
Lin_fun_freq_y(7)=Lin_Freq_y_7(Lin_Ix7);
Lin_fun_freq_y(8)=Lin_Freq_y_8(Lin_Ix8);
Lin_fun_freq_y(9)=Lin_Freq_y_9(Lin_Ix9);
Lin_fun_freq_y(10)=Lin_Freq_y_10(Lin_Ix10);
Lin_fun_freq_y(11)=Lin_Freq_y_11(Lin_Ix11);
Lin_fun_freq_y(12)=Lin_Freq_y_12(Lin_Ix12);
Lin_fun_freq_y(13)=Lin_Freq_y_13(Lin_Ix13);
Lin_fun_freq_y(14)=Lin_Freq_y_14(Lin_Ix14);
Lin_fun_freq_y(15)=Lin_Freq_y_15(Lin_Ix15);
Lin_fun_freq_y(16)=Lin_Freq_y_16(Lin_Ix16);
Lin_fun_freq_y(17)=Lin_Freq_y_17(Lin_Ix17);
Lin_fun_freq_y(18)=Lin_Freq_y_18(Lin_Ix18);
Lin_fun_freq_y(19)=Lin_Freq_y_19(Lin_Ix19);
Lin_fun_freq_y(20)=Lin_Freq_y_20(Lin_Ix20);
%% Calculation of spectra

% CF response (displacement) of the node the maximum response amplitude

% Matrix with the time steps and the respective CF responses
Lin_resp_z_1=[t Lin_Res_z_1(:,Lin_Index_z(1))];
Lin_resp_z_2=[t Lin_Res_z_2(:,Lin_Index_z(2))];
Lin_resp_z_3=[t Lin_Res_z_3(:,Lin_Index_z(3))];
Lin_resp_z_4=[t Lin_Res_z_4(:,Lin_Index_z(4))];
Lin_resp_z_5=[t Lin_Res_z_5(:,Lin_Index_z(5))];
Lin_resp_z_6=[t Lin_Res_z_6(:,Lin_Index_z(6))];
Lin_resp_z_7=[t Lin_Res_z_7(:,Lin_Index_z(7))];
Lin_resp_z_8=[t Lin_Res_z_8(:,Lin_Index_z(8))];
Lin_resp_z_9=[t Lin_Res_z_9(:,Lin_Index_z(9))];
Lin_resp_z_10=[t Lin_Res_z_10(:,Lin_Index_z(10))];
Lin_resp_z_11=[t11 Lin_Res_z_11(:,Lin_Index_z(11))];
Lin_resp_z_12=[t Lin_Res_z_12(:,Lin_Index_z(12))];
Lin_resp_z_13=[t Lin_Res_z_13(:,Lin_Index_z(13))];
Lin_resp_z_14=[t Lin_Res_z_14(:,Lin_Index_z(14))];
Lin_resp_z_15=[t Lin_Res_z_15(:,Lin_Index_z(15))];
Lin_resp_z_16=[t Lin_Res_z_16(:,Lin_Index_z(16))];
Lin_resp_z_17=[t Lin_Res_z_17(:,Lin_Index_z(17))];
Lin_resp_z_18=[t Lin_Res_z_18(:,Lin_Index_z(18))];
Lin_resp_z_19=[t Lin_Res_z_19(:,Lin_Index_z(19))];
Lin_resp_z_20=[t Lin_Res_z_20(:,Lin_Index_z(20))];

% Structure to be used in WAFO

Lin_Sp_z_1=dat2spec(Lin_resp_z_1,1000);
Lin_Sp_z_2=dat2spec(Lin_resp_z_2,1000);
Lin_Sp_z_3=dat2spec(Lin_resp_z_3,1000);
Lin_Sp_z_4=dat2spec(Lin_resp_z_4,1000);
Lin_Sp_z_5=dat2spec(Lin_resp_z_5,1000);
Lin_Sp_z_6=dat2spec(Lin_resp_z_6,1000);
Lin_Sp_z_7=dat2spec(Lin_resp_z_7,1000);
Lin_Sp_z_8=dat2spec(Lin_resp_z_8,1000);
Lin_Sp_z_9=dat2spec(Lin_resp_z_9,1000);
Lin_Sp_z_10=dat2spec(Lin_resp_z_10,1000);
Lin_Sp_z_11=dat2spec(Lin_resp_z_11,1000);
Lin_Sp_z_12=dat2spec(Lin_resp_z_12,1000);
Lin_Sp_z_13=dat2spec(Lin_resp_z_13,1000);
Lin_Sp_z_14=dat2spec(Lin_resp_z_14,1000);
Lin_Sp_z_15=dat2spec(Lin_resp_z_15,1000);
Lin_Sp_z_16=dat2spec(Lin_resp_z_16,1000);
Lin_Sp_z_17=dat2spec(Lin_resp_z_17,1000);
Lin_Sp_z_18=dat2spec(Lin_resp_z_18,1000);
Lin_Sp_z_19=dat2spec(Lin_resp_z_19,1000);
Lin_Sp_z_20=dat2spec(Lin_resp_z_20,1000);


% Response Spectra of the CF Response Calculated using WAFO
Lin_Spec_z_1=Lin_Sp_z_1.S*2*pi; 
Lin_Spec_z_2=Lin_Sp_z_2.S*2*pi;
Lin_Spec_z_3=Lin_Sp_z_3.S*2*pi;
Lin_Spec_z_4=Lin_Sp_z_4.S*2*pi;
Lin_Spec_z_5=Lin_Sp_z_5.S*2*pi;
Lin_Spec_z_6=Lin_Sp_z_6.S*2*pi;
Lin_Spec_z_7=Lin_Sp_z_7.S*2*pi;
Lin_Spec_z_8=Lin_Sp_z_8.S*2*pi;
Lin_Spec_z_9=Lin_Sp_z_9.S*2*pi;
Lin_Spec_z_10=Lin_Sp_z_10.S*2*pi;
Lin_Spec_z_11=Lin_Sp_z_11.S*2*pi;
Lin_Spec_z_12=Lin_Sp_z_12.S*2*pi;
Lin_Spec_z_13=Lin_Sp_z_13.S*2*pi;
Lin_Spec_z_14=Lin_Sp_z_14.S*2*pi;
Lin_Spec_z_15=Lin_Sp_z_15.S*2*pi;
Lin_Spec_z_16=Lin_Sp_z_16.S*2*pi;
Lin_Spec_z_17=Lin_Sp_z_17.S*2*pi;
Lin_Spec_z_18=Lin_Sp_z_18.S*2*pi;
Lin_Spec_z_19=Lin_Sp_z_19.S*2*pi;
Lin_Spec_z_20=Lin_Sp_z_20.S*2*pi;


% Frequencies of the CF Response calculated using WAFO
Lin_Freq_z_1=Lin_Sp_z_1.w/(2*pi);
Lin_Freq_z_2=Lin_Sp_z_2.w/(2*pi);
Lin_Freq_z_3=Lin_Sp_z_3.w/(2*pi);
Lin_Freq_z_4=Lin_Sp_z_4.w/(2*pi);
Lin_Freq_z_5=Lin_Sp_z_5.w/(2*pi);
Lin_Freq_z_6=Lin_Sp_z_6.w/(2*pi);
Lin_Freq_z_7=Lin_Sp_z_7.w/(2*pi);
Lin_Freq_z_8=Lin_Sp_z_8.w/(2*pi);
Lin_Freq_z_9=Lin_Sp_z_9.w/(2*pi);
Lin_Freq_z_10=Lin_Sp_z_10.w/(2*pi);
Lin_Freq_z_11=Lin_Sp_z_11.w/(2*pi);
Lin_Freq_z_12=Lin_Sp_z_12.w/(2*pi);
Lin_Freq_z_13=Lin_Sp_z_13.w/(2*pi);
Lin_Freq_z_14=Lin_Sp_z_14.w/(2*pi);
Lin_Freq_z_15=Lin_Sp_z_15.w/(2*pi);
Lin_Freq_z_16=Lin_Sp_z_16.w/(2*pi);
Lin_Freq_z_17=Lin_Sp_z_17.w/(2*pi);
Lin_Freq_z_18=Lin_Sp_z_18.w/(2*pi);
Lin_Freq_z_19=Lin_Sp_z_19.w/(2*pi);
Lin_Freq_z_20=Lin_Sp_z_20.w/(2*pi);

% Finding the peak frequencies of the CF Response
[Lin_M1,Lin_I1]=max(Lin_Spec_z_1(:));
[Lin_M2,Lin_I2]=max(Lin_Spec_z_2(:));
[Lin_M3,Lin_I3]=max(Lin_Spec_z_3(:));
[Lin_M4,Lin_I4]=max(Lin_Spec_z_4(:));
[Lin_M5,Lin_I5]=max(Lin_Spec_z_5(:));
[Lin_M6,Lin_I6]=max(Lin_Spec_z_6(:));
[Lin_M7,Lin_I7]=max(Lin_Spec_z_7(:));
[Lin_M8,Lin_I8]=max(Lin_Spec_z_8(:));
[Lin_M9,Lin_I9]=max(Lin_Spec_z_9(:));
[Lin_M10,Lin_I10]=max(Lin_Spec_z_10(:));
[Lin_M11,Lin_I11]=max(Lin_Spec_z_11(:));
[Lin_M12,Lin_I12]=max(Lin_Spec_z_12(:));
[Lin_M13,Lin_I13]=max(Lin_Spec_z_13(:));
[Lin_M14,Lin_I14]=max(Lin_Spec_z_14(:));
[Lin_M15,Lin_I15]=max(Lin_Spec_z_15(:));
[Lin_M16,Lin_I16]=max(Lin_Spec_z_16(:));
[Lin_M17,Lin_I17]=max(Lin_Spec_z_17(:));
[Lin_M18,Lin_I18]=max(Lin_Spec_z_18(:));
[Lin_M19,Lin_I19]=max(Lin_Spec_z_19(:));
[Lin_M20,Lin_I20]=max(Lin_Spec_z_20(:));

Lin_fun_freq_z=zeros(20,1);
Lin_fun_freq_z(1)=Lin_Freq_z_1(Lin_I1);
Lin_fun_freq_z(2)=Lin_Freq_z_2(Lin_I2);
Lin_fun_freq_z(3)=Lin_Freq_z_3(Lin_I3);
Lin_fun_freq_z(4)=Lin_Freq_z_4(Lin_I4);
Lin_fun_freq_z(5)=Lin_Freq_z_5(Lin_I5);
Lin_fun_freq_z(6)=Lin_Freq_z_6(Lin_I6);
Lin_fun_freq_z(7)=Lin_Freq_z_7(Lin_I7);
Lin_fun_freq_z(8)=Lin_Freq_z_8(Lin_I8);
Lin_fun_freq_z(9)=Lin_Freq_z_9(Lin_I9);
Lin_fun_freq_z(10)=Lin_Freq_z_10(Lin_I10);
Lin_fun_freq_z(11)=Lin_Freq_z_11(Lin_I11);
Lin_fun_freq_z(12)=Lin_Freq_z_12(Lin_I12);
Lin_fun_freq_z(13)=Lin_Freq_z_13(Lin_I13);
Lin_fun_freq_z(14)=Lin_Freq_z_14(Lin_I14);
Lin_fun_freq_z(15)=Lin_Freq_z_15(Lin_I15);
Lin_fun_freq_z(16)=Lin_Freq_z_16(Lin_I16);
Lin_fun_freq_z(17)=Lin_Freq_z_17(Lin_I17);
Lin_fun_freq_z(18)=Lin_Freq_z_18(Lin_I18);
Lin_fun_freq_z(19)=Lin_Freq_z_19(Lin_I19);
Lin_fun_freq_z(20)=Lin_Freq_z_20(Lin_I20);

%% Plots

%% Plots of Spectra using different methods
% Using WAFO
figure
plot(Freq_y_19,Spec_y_19,'b')
 legend('IL')
xlabel('Frequency f [Hz]')
ylabel('S(f)')
hold off

figure
plot(Freq_z_19,Spec_z_19,'r')
 legend('CF')
xlabel('Frequency f [Hz]')
ylabel('S(f)')
hold off
%%
figure
plotspec(Sp_y_19)
title('IL')
xlabel('Frequency $\omega$ [rad/s]','Interpreter','latex')
ylabel('S($\omega$)','Interpreter','latex')

figure
plotspec(Sp_z_19)
title('CF')
xlabel('Frequency $\omega$ [rad/s]','Interpreter','latex')
ylabel('S($\omega$)','Interpreter','latex')
%%
% Using Method 2
[Spciy,fy,Nhiy]=spec(Res_y_19(:,Index(19)),ns,Fs); %IL displacement
[Spciz,fz,Nhiz]=spec(Res_z_19(:,Index_z(19)),ns,Fs); %CF displacement
figure
plot(fy(1:Nhiy),Spciy(1:Nhiy),'b')

legend('IL')
xlabel('Frequency f [Hz]')
ylabel('S(f)')


figure
plot(fz(1:Nhiz),Spciz(1:Nhiz),'r')
legend('CF')
xlabel('Frequency f [Hz]')
ylabel('S(f)')

%%
% Uzing Method 3
L1 = numel(Res_y_19(:,Index(19)));                   % Signal Length
Fn = Fs/2;                              % Nyquist Frequency
FTs = fft(Res_y_19(:,Index(19)) - mean(Res_y_19(:,Index(19))))/L1; % Subtract Mean To See Other Peaks
Fv = linspace(0, 1, fix(L1/2)+1)*Fn;     % Frequency Vector
Iv = 1:numel(Fv);                       % Index Vector

figure
plot(Fv, abs(FTs(Iv))*2,'b')
grid
legend('IL')
xlabel('Frequency f [Hz]')
ylabel('S(f)')

L1 = numel(Res_z_19(:,Index_z(19)));                   % Signal Length
Fn = Fs/2;                              % Nyquist Frequency
FTs = fft(Res_z_19(:,Index_z(19)) - mean(Res_z_19(:,Index_z(19))))/L1; % Subtract Mean To See Other Peaks
Fv = linspace(0, 1, fix(L1/2)+1)*Fn;     % Frequency Vector
Iv = 1:numel(Fv);                       % Index Vector

figure
plot(Fv, abs(FTs(Iv))*2,'r')
grid
legend('CF')
xlabel('Frequency f [Hz]')
ylabel('S(f)')

%% Plot of peak frequencies
figure
plot(u_cur,Lin_fun_freq_y,'b-x')
hold on
plot(u_cur,Lin_fun_freq_z,'r-+')
hold off
legend('IL-TD','CF-TD','location','best')
xlabel('Current Velocity U [m/s]')
ylabel('Frequency f [Hz]')

%%  Plot of Maximum Response Amplitudes
figure
plot(u_cur,Lin_A_y_max/D,'bx-')
hold on
plot(u_cur,Lin_A_z_max/D,'r+-')
hold off
legend('IL-TD','CF-TD','location','northwest')
xlabel('Current Velocity U [m/s]')
ylabel('A_{max}/D')

%% Snapshots

%% 0.5 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_1(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,1)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(1,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(1,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('0.5 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_1(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,2)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(1,:),(Lin_Seafloor_z_final(1,:)),'-.g','linewidth',3);
hold off
title('0.5 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 0.6 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_2(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,3)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(2,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(2,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('0.6 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_2(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,4)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(2,:),(Lin_Seafloor_z_final(2,:)),'-.g','linewidth',3);
hold off
title('0.6 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 0.7 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_3(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,5)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(3,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(3,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('0.7 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_3(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,6)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(3,:),(Lin_Seafloor_z_final(3,:)),'-.g','linewidth',3);
hold off
title('0.7 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 0.8 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_4(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,7)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(4,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(4,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('0.8 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_4(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,8)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(4,:),(Lin_Seafloor_z_final(4,:)),'-.g','linewidth',3);
hold off
title('0.8 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 0.9 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_5(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,9)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(5,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(5,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('0.9 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_5(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,10)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(5,:),(Lin_Seafloor_z_final(5,:)),'-.g','linewidth',3);
hold off
title('0.9 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.0 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_6(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,11)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(6,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(6,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.0 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_6(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,12)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(6,:),(Lin_Seafloor_z_final(6,:)),'-.g','linewidth',3);
hold off
title('1.0 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.1 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_7(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,13)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(7,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(7,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.1 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_7(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,14)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(7,:),(Lin_Seafloor_z_final(7,:)),'-.g','linewidth',3);
hold off
title('1.1 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.2 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_8(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,15)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(8,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(8,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.2 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_8(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,16)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(8,:),(Lin_Seafloor_z_final(8,:)),'-.g','linewidth',3);
hold off
title('1.2 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
%% 1.3 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_9(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,17)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(9,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(9,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.3 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_9(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,18)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(9,:),(Lin_Seafloor_z_final(9,:)),'-.g','linewidth',3);
hold off
title('1.3 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.4 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_10(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,19)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(10,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(10,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.4 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_10(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,20)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(10,:),(Lin_Seafloor_z_final(10,:)),'-.g','linewidth',3);
hold off
title('1.4 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.5 m/s
figure
hold on
for i=1:450:170001
    
h1=plot(cord,Lin_Res_y_11(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,21)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(11,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(11,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.5 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:450:170001
    
h1=plot(cord,Lin_Res_z_11(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,22)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(11,:),(Lin_Seafloor_z_final(11,:)),'-.g','linewidth',3);
hold off
title('1.5 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.6 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_12(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,23)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(12,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(12,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.6 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_12(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,24)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(12,:),(Lin_Seafloor_z_final(12,:)),'-.g','linewidth',3);
hold off
title('1.6 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.7 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_13(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,25)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(13,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(13,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.7 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_13(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,26)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(13,:),(Lin_Seafloor_z_final(13,:)),'-.g','linewidth',3);
hold off
title('1.7 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.8 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_14(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,27)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(14,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(14,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.8 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_14(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,28)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(14,:),(Lin_Seafloor_z_final(14,:)),'-.g','linewidth',3);
hold off
title('1.8 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 1.9 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_15(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,29)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(15,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(15,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('1.9 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_15(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,30)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(15,:),(Lin_Seafloor_z_final(15,:)),'-.g','linewidth',3);
hold off
title('1.9 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
%% 2.0 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_16(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,31)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(16,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(16,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('2.0 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_16(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,32)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(16,:),(Lin_Seafloor_z_final(16,:)),'-.g','linewidth',3);
hold off
title('2.0 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 2.1 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_17(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,33)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(17,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(17,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('2.1 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_17(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,34)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(17,:),(Lin_Seafloor_z_final(17,:)),'-.g','linewidth',3);
hold off
title('2.1 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 2.2 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_18(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,35)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(18,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(18,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('2.2 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_18(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,36)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(18,:),(Lin_Seafloor_z_final(18,:)),'-.g','linewidth',3);
hold off
title('2.2 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 2.3 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_19(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,37)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(19,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(19,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('2.3 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_19(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,38)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(19,:),(Lin_Seafloor_z_final(19,:)),'-.g','linewidth',3);
hold off
title('2.3 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')

%% 2.4 m/s
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_y_20(i,:),'b');
end
h2=plot(cord,(Lin_Static_yz(:,39)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(20,1:61),zeros(1,61),'-.g','linewidth',3);
plot(Lin_Seafloor_x_final(20,115:175),zeros(1,61),'-.g','linewidth',3)
hold off
title('2.4 m/s')
legend([h1,h2,h3],{'IL Dynamic','IL Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
figure
hold on
for i=1:150:68001
    
h1=plot(cord,Lin_Res_z_20(i,:),'r');
end
h2=plot(cord,(Lin_Static_yz(:,40)),'k','linewidth',2);
h3=plot(Lin_Seafloor_x_final(20,:),(Lin_Seafloor_z_final(20,:)),'-.g','linewidth',3);
hold off
title('2.4 m/s')
legend([h1,h2,h3],{'CF Dynamic','CF Static','Seafloor'},'location','best')
xlabel('Position [m]')
ylabel('A [m]')
