%YURA87  Surface elevation measured off the coast of Yura.
%    
%   CALL:  xn = load('yura87.dat');
%   
%  Size             :    85547 X 4
%  Sampling Rate    :    1 Hz
%  Device           :    ultrasonic wave gauges
%  Source           :    SRI, Ministry of Transport, Japan 
%  Format           :    ascii, c1: time (sec) c2-4: surface elevation (m)
%  Description      :
%    The wave data was measured at the Poseidon platform  
%    in the Japan Sea from 24th November 1987 08.12 hours to 25th November 
%    1987 07.57 hours. Poseidon was located 3 km off the coast of Yura 
%    in the Yamagata prefecture, in the Japan Sea during the measurements. 
%    The most important wave components are to some extent influenced by the 
%    water depth of 42 m. The data are measured with three ultrasonic wave 
%    gauges located at the sea floor and the relative coordinates of the 
%    gauges are as follows (x-axis points to the East, y-axis points to 
%    the North):
%             X (m)    Y (m)
%      c2:   -4.93,    25.02
%      c3:    5.80,    92.12
%      c4:    0.00,     0.00
%  
%    This dataset is for non-commercial use only.
%
%    Hm0 = 5.1m, Tm02 = 7.7s, Tp = 12.8s
%
%  Acknowledgement:
%    This dataset were prepared and made available by Dr. Sc. H. Tomita, 
%    Ship Research Institute, Ministry of Transport, Japan.
%  
%  See also  japansea
