%ABOUTWAFO  WAFO is a Matlab toolbox for analysis of random waves
%
% WAFO (Wave Analysis for Fatigue and Oceanography) is a toolbox of
% Matlab routines for statistical analysis and simulation of random waves 
% and random loads, and for calculation of the theoretical distributions
% related to the wave structure.
%
% The toolbox contains libraries and demonstration files, referring to
% papers, i.e. scripts for comparison of results in the litterature or
% generation of plots in recent publications. For modelling purposes
% within oceanography, families of common spectra and spreading functions 
% are implemented.
%
% For the modelling of sea waves, an important class of processes are
% stationary Gaussian processes with known spectral density. For these it 
% is possible to calculate the theoretical distribution of wave
% characterisics, e.g probability density for wave length or joint
% probability density for wave length and amplitude. Some routines handle 
% the case with random fields, taking dynamics of the sea into
% account. WAFO also contains algorithms for modelling with transformed
% Gaussian processes.
%
% An important part of WAFO are routines related to random loads and
% fatigue. For a random load, rainflow cycles can be extracted and the
% expected rainflow matrix can be calculated. Additional routines for
% more complex models, e.g model involving switching Markov chains of
% turning points, are also found.
%
% See also  docs 

% Reference
% Brodtkorb, P.A, and Johannesson, P and Lindgren, G. and  Rychlik, I. and
%  Ryden,R and Sj\"o, E (2000)
% "WAFO - a Matlab toolbox for analysis of random waves"
% To appear in the Proceedings of the 10th ISOPE Conference


% History
% by pab et.al. 21.01.2000

more  on
help aboutwafo
more off


%function aboutwafo