% AMPDEF wave heights and amplitude definitions and nomenclature
%
% Definition of wave amplitude and wave heights:
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%            <----- Direction of wave propagation
% 
%             
%           ...............c_..........
%           |             /| \         |
%       Hd  |           _/ |  \        |  Hu
%   M       |          /   |   \       |
%  / \      |     M   / Ac |    \_     |     c_  
% F   \     |    / \m/     |      \    |    /  \ 
%------d----|---u------------------d---|---u----d------ level v
%       \   |  /|                   \  |  /      \L
%        \_ | / | At                 \_|_/     
%          \|/..|                      t
%           t
% 
%  Ac   = crest amplitude
%  At   = trough amplitude
%  Hd   = wave height as defined for down crossing waves
%  Hu   = wave height as defined for up crossing waves
%
% See also  wavedef, ampdef, crossdef, tpdef

% history:
% revised pab 21.01.2000
% -  changed  from: Wave propagating direction 
%               to: Direction of wave propagation
% revised pab 12.12.1999
%  added help ampdef
% by Per A. Brodtkorb 19.09.1999
%

more on
help ampdef
more off
