function wafointro
%WAFOINTRO  Info about WAFODEMO: WAFO - a Matlab toolbox for analysis of random waves and loads
%
% The files in this directory can reproduce the figures in the 
% article of 
% 
% Brodtkorb, P.A., Johannesson, P., Lindgren, G., Rychlik, I., Ryden, J
% and Sjo, E. (2000)
% 'WAFO - a Matlab toolbox for analysis of random waves and loads'
%  to appear in Proceedings of 10th ISOPE Conference, Seattle
% 
%
% The paper demonstrates in examples some of the capabilities of WAFO:
%
%   - Construction of model spectra, directional model spectra with known 
%     spreading function
%   - Simulation of transformed Gaussian processes
%   - Spectral density estimation
%   - Probability distributions of wave characteristics:
%        1) Joint density of Vcf and Ac
%        2) Joint density of Tcf and Ac given Tc=5
%        3) Distribution of extremal crest
%   - Fatigue, Cycles and Markov models
%
%   (See wafomenu for numenclature and wave parameter definitions)
%
% See also  wafomenu, recdemo

% TODO % Needs more details regarding what this demo is about

% Tested on: Matlab 5.2
% history:
% By pab 28.01.2000

%more on
help wafointro
%more off
